/*
* QuData Chat Builder Plugin.
*
* @copyright Copyright (C) 2021, qudata.com
*/
window.editorConfig = JSON.parse(`{
    "version":    "1.0.61",
    "botManager": "https://services.qudata.com/bot/manager/api/",
    "analytics":  "https://services.qudata.com/bot/analytics/api/v1/"
  }`);

class QuBotData {
    constructor() {
        this.type = null, this.clientToken = null, this.isToken = !1;
    }
    saveBot(botID, name, data, callback = 0) {}
    loadBot(botID, callback = 0) {}
    deleteBot(botID, callback = 0) {}
    save(name, data, callback = 0) {}
    load(name, callback = 0) {}
    getDate(today) {
        let mm = (today.getMonth() + 1).toString(), dd = today.getDate().toString();
        return 1 === mm.length && (mm = "0" + mm), 1 === dd.length && (dd = "0" + dd), today.getFullYear() + "-" + mm + "-" + dd;
    }
    getTime(today) {
        let hh = today.getHours().toString(), mm = today.getMinutes().toString(), ss = today.getSeconds().toString();
        return 1 === hh.length && (hh = "0" + hh), 1 === mm.length && (mm = "0" + mm), 1 === ss.length && (ss = "0" + ss), 
        hh + ":" + mm + ":" + ss;
    }
    getDateTime(today) {
        return this.getDate(today) + " " + this.getTime(today);
    }
    send(storage, ownerID, botID, key, value, callback = 0) {}
    receive(storage, ownerID, botID, last = 0, callback) {}
    sendAnalytics(request, callback = 0) {}
    sendBotManager(request, callback = 0) {}
    setClientToken(token) {
        this.isToken = 10 < token.length, this.clientToken = this.isToken ? token : null;
    }
    extension(extensionName, version, requestName, requestBody, callback = 0) {}
    encodeStr(str) {
        if (!str) return str;
        var mapObj = {
            "<": "__qlt;",
            ">": "__qgt;",
            "&": "__qamp;"
        };
        return str.replace(/<|>|&/gi, function(matched) {
            return mapObj[matched];
        });
    }
    decodeStr(str) {
        if (!str) return str;
        var mapObj = {
            "__qlt;": "<",
            "__qgt;": ">",
            "__qamp;": "&"
        };
        return str.replace(/__qlt;|__qgt;|__qamp;/gi, function(matched) {
            return mapObj[matched];
        });
    }
    getClientToken() {
        return this.clientToken;
    }
    sendPost(url, request, headers = null, callback = function(obj) {}) {
        const xhrRequest = new XMLHttpRequest();
        for (var header in xhrRequest.responseType = "json", xhrRequest.open("POST", url, !0), 
        headers) xhrRequest.setRequestHeader(header, headers[header]);
        xhrRequest.addEventListener("readystatechange", function() {
            var result;
            4 === xhrRequest.readyState && 200 === xhrRequest.status && (result = xhrRequest.response, 
            callback(result));
        }), xhrRequest.send(request);
    }
}

class QuBotDataWP extends QuBotData {
    constructor(plugin_dir_url, ajaxUrl) {
        super(), this.type = "WP", this.pathIcons = plugin_dir_url + "qubot/css/icons/", 
        this.pathStyles = plugin_dir_url + "qubot/css/styles/", this.ajaxURL = ajaxUrl, 
        this.cid = "7b6d77019f4ff38767bb5256aa22262c";
    }
    save(name, data, callback = function(status) {}) {
        const request = new XMLHttpRequest();
        data = encodeURIComponent(data);
        request.open("POST", this.ajaxURL, !0), request.responseType = "json", request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            4 === request.readyState && 200 === request.status && (request.response, callback({
                status: !0
            }));
        }), request.send(name + "=" + data + "&action=ajaxSetup");
    }
    load(name, callback = function(obj) {}) {
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            if (4 === request.readyState && 200 === request.status) {
                var data = request.response;
                try {
                    var obj = JSON.parse(data);
                    callback(obj);
                } catch (e) {
                    callback(null);
                }
            }
        }), request.send("action=ajaxSetup&loadSetup=" + name);
    }
    saveBot(botID, name, data, callback = function(status) {}) {
        botID = JSON.stringify({
            botID: botID,
            name: name,
            data: data
        }), name = this.encodeStr(botID), data = encodeURIComponent(name);
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            4 === request.readyState && 200 === request.status && (request.response, callback({
                status: !0
            }));
        }), request.send("action=ajaxSetup&saveBot=" + data);
    }
    loadBot(botID, callback = function(data) {}) {
        botID = JSON.stringify({
            botID: botID
        }), botID = encodeURIComponent(botID);
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            if (4 === request.readyState && 200 === request.status) {
                var dataEncoded = request.response;
                try {
                    var data = this.decodeStr(dataEncoded), bot = JSON.parse(data), botData = JSON.parse(bot.data);
                    callback(botData);
                } catch (e) {
                    callback(null);
                }
            }
        }.bind(this)), request.send("action=ajaxSetup&loadBot=" + botID);
    }
    deleteBot(botID, callback = function(data) {}) {
        botID = encodeURIComponent(JSON.stringify({
            botID: botID
        }));
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            4 === request.readyState && 200 === request.status && (request.response, callback({
                status: !0
            }));
        }), request.send("action=ajaxSetup&deleteBot=" + botID);
    }
    send(storage, ownerID, botID, UID, value, callback = function(status) {}) {
        storage = {
            storage: storage,
            ownerID: ownerID,
            botID: botID,
            uid: UID,
            time: this.getDateTime(new Date()),
            value: JSON.stringify(value)
        }, ownerID = encodeURIComponent(JSON.stringify(storage));
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            4 === request.readyState && 200 === request.status && (request.response, callback({
                status: !0
            }));
        }), request.send("action=ajaxSetup&sendUserData=" + ownerID);
    }
    receive(storage, ownerID, botID, last = 0, callback = function(obj) {}) {
        storage = encodeURIComponent(JSON.stringify({
            storage: storage,
            ownerID: ownerID,
            botID: botID
        }));
        const request = new XMLHttpRequest();
        request.open("POST", this.ajaxURL, !0), request.setRequestHeader("Content-type", "application/x-www-form-urlencoded"), 
        request.addEventListener("readystatechange", function() {
            if (4 === request.readyState && 200 === request.status) {
                var data = request.response;
                try {
                    let rows = JSON.parse(data);
                    rows && rows.forEach(row => row.value = JSON.parse(row.value)), callback(rows);
                } catch (e) {
                    callback(null);
                }
            }
        }), request.send("action=ajaxSetup&receiveUserData=" + storage);
    }
    sendAnalytics(request, callback = function(obj) {}) {
        var url;
        this.isToken && (request.request, url = this.ajaxURL, this.sendPost(url, "action=ajaxSetup&analytics=" + JSON.stringify(request), {
            "Content-type": "application/x-www-form-urlencoded"
        }, callback));
    }
    sendBotManager(request, callback = function(obj) {}) {
        var url;
        this.isToken && (request.request, request.plugin = "wordpress", url = this.ajaxURL, 
        this.sendPost(url, "action=ajaxSetup&botManager=" + JSON.stringify(request), {
            "Content-type": "application/x-www-form-urlencoded"
        }, callback));
    }
}

class QuBotVisual {
    constructor() {
        this.uid = null, this.id = 0, this.start = "", this.states = {}, this.slots = {}, 
        this.localSlots = {}, this.name = "Unknown", this.wasClose = !1, this.clearThisMessage = !1, 
        this.buttons = [], this.checks = [], this.radios = [], this.medias = [], this.nlu = null, 
        this.chat = null, this.extractor = new QuBotExtractor(), this.debug = new QuBotDebug(), 
        this.events = new QuBotEvents(), this.curState = "", this.newState = "", this.timers = [], 
        this.wasGoto = !1;
    }
    set(bot, uid) {
        this.states = bot.states, this.slots = bot.slots, this.start = bot.start, this.id = bot.id, 
        this.uid = uid, this.name = bot.name, this.events.init(this.id, this.uid), this.events.send(), 
        this.events.clear();
    }
    START_STATE(restart, lang = "en") {
        if (this.events.push("start"), this.chat = document.getElementById("qubot"), this.curState = this.newState = this.start, 
        restart || !this.load()) {
            for (var slot in this.slots) this.slots[slot] = null;
            this.slots.LANGUAGE = lang, this.slots.INPUT = "";
        }
        this.buttons = [], this.checks = [], this.radios = [], this.createNLU(), this.showState(this.curState);
    }
    showState(state) {
        if (this.chat || (this.chat = document.getElementById("qubot")), state = (state = state || this.newState) || this.curState) {
            if (0 === state.indexOf("http://") || 0 === state.indexOf("https://")) return window.open(state, "_blank"), 
            this.clearThisMessage = !0, this.clearMessages(1), this.clearThisMessage = !1, this.newState = this.curState, 
            setTimeout(this.showState.bind(this), 1), void this.gotoBottom();
            0 < state.length && (this.curState = state), state in this.states ? (this.clearThisMessage && (this.clearMessages(1), 
            this.clearThisMessage = !1, this.gotoBottom()), this.images = null, this.events.push("ST_" + state), 
            this.save(), this.debug.add(`<b>step</b> <span class="green">${state}</span><br>`), 
            this.clearTimers(), this.newState = "", this.wasGoto = !1, this.rowID = 0, this.itemID = 0, 
            this.content = null, document.getElementById("qubot-input").disabled = !0, this.showStateItems(this.states[state]), 
            this.gotoBottom()) : this.debug.add('<span class="red">Unknown step:</span> ' + state);
        } else this.debug.add(`<span class="red">Empty step:</span> "${state}"`);
    }
    showStateItems(items) {
        for (;this.itemID < items.length && !this.wasGoto; this.itemID++) {
            let item = items[this.itemID];
            if ("message" === item.type) {
                this.addCustomMessage(item);
                break;
            }
            if ("text" === item.type) this.addText(item); else if ("row" === item.type) {
                this.addRow();
                let btnID = 0;
                item.items.forEach(btn => {
                    this.addButton(this.rowID, btnID, btn), btnID++;
                }), this.rowID++;
            } else if ("images" === item.type) this.appendImages(), item.items.forEach(image => {
                this.addImage(image);
            }); else if ("map" === item.type) this.appendMap(item); else if ("video" === item.type) this.appendMedia(item, "video"); else if ("audio" === item.type) this.appendMedia(item, "audio"); else if ("timer" === item.type) this.addTimer(item); else if ("actions" === item.type && (this.runActions(item.actions), 
            this.wasGoto)) break;
        }
        (this.itemID >= items.length || this.wasGoto) && (this.correctRadio(), this.wasGoto && (this.content && !this.content.innerHTML && this.content.parentNode.parentNode.remove(), 
        setTimeout(this.showState.bind(this), 1)), this.debug.show(this.curState, this.slots), 
        this.gotoBottom(), this.isInputActions(this.curState) && (document.getElementById("qubot-input").disabled = !1), 
        this.wasClose || document.getElementById("qubot-input").focus());
    }
    addCustomMessage(item) {
        var time;
        this.content && !this.content.innerHTML && this.content.parentNode.parentNode.remove(), 
        "typing" in item && !isNaN(item.typing) && 0 < item.typing ? (this.curItem = item, 
        this.typingBlock = this.addTypingBlock(), time = parseInt(item.typing), setTimeout(this.typingTimer.bind(this), time)) : (this.addMessage(), 
        "back" in item && item.back && (this.content.style.backgroundColor = item.back), 
        this.itemID++, this.showStateItems(this.states[this.curState])), this.gotoBottom();
    }
    typingTimer() {
        this.typingBlock.remove(), this.addMessage(), "back" in this.curItem && this.curItem.back && (this.content.style.background = this.curItem.back), 
        this.itemID++, this.showStateItems(this.states[this.curState]), this.gotoBottom();
    }
    correctRadio() {
        if (this.radios.length) {
            let numChecks = 0;
            for (let i = 0; i < this.radios.length; i++) this.radios[i].item.checked && numChecks++;
            if (numChecks) {
                if (1 < numChecks) {
                    this.radios[0].item.checked = !0;
                    for (let i = 1; i < this.radios.length; i++) this.radios[i].item.checked = !1;
                }
            } else this.radios[0].item.checked = !0;
        }
    }
    runButton(btnIndex, rowID, btnID) {
        if (this.debug.clear(), this.debug.add(`<b>button</b> <span class="green">${btnIndex} (row:${rowID} col:${btnID}) </span><br>`), 
        btnIndex < 0 || btnIndex >= this.buttons.length) this.debug.add(`<span class="red">Wrong button index = ${btnIndex}</span><br>`); else {
            let button = this.buttons[btnIndex].item;
            if ("check" === button.kind) button.checked = !button.checked; else if ("radio" === button.kind) {
                for (let i = 0; i < this.radios.length; i++) this.radios[i].item.checked = !1;
                button.checked = !0;
            }
            this.runActions(button.actions), this.addAnswer(this.getText(button.button)), this.debug.add("<br>"), 
            this.debug.show(this.curState, this.slots), this.newState || (this.newState = this.curState), 
            this.buttons = [], this.checks = [], this.radios = [], this.stopMedia(), setTimeout(this.showState.bind(this), 1), 
            this.gotoBottom();
        }
    }
    inputEnter(event) {
        13 === (event.keyCode || event.which) && this.input();
    }
    input() {
        let inp = document.getElementById("qubot-input");
        var value = inp.value.trim();
        if (inp.value = "", value.length) if ("/help" == value) this.addText({
            text: `
                    <b>/start</b> - start the bot from start state
                    <b>/restart</b> - restart  (slots=null)
                    <b>/debug</b> - show debug window
                    <b>/info</b>  - info about current state
                    <b>/data</b>  - 10 recently saved records
                `
        }); else if ("/start" == value) this.START_STATE(); else if ("/restart" == value) this.clear(), 
        this.debug.clear(), this.debug.show(this.curState, this.slots); else if ("/debug" == value) this.debug.create(this.curState), 
        this.debug.show(this.curState, this.slots); else if ("/info" == value) {
            let txt = "bid: " + this.id + "<br>";
            txt += "uid: " + this.uid + "<br>", txt += "state: " + this.curState + "<br>", txt += "start: " + this.start, 
            this.addText({
                text: txt
            });
        } else "/data" == value ? qubotData.receive("wp", 1, this.id, 10, function(data) {
            if (data) {
                let txt = "id:" + this.id + "<br>";
                for (let i = 0; i < data.length; i++) txt += JSON.stringify(data[i]) + "<br>";
                this.addText({
                    text: txt
                });
            }
        }.bind(this)) : (this.addAnswer(value), this.inputText(value));
        this.debug.add("<br>"), this.stopMedia(), this.gotoBottom();
    }
    inputText(text) {
        this.debug.clear(), this.debug.add(`<b>input</b>: ${text}<br>`), this.slots.INPUT = "'" + text + "'";
        for (let i = this.states[this.curState].length - 1; 0 <= i; i--) {
            var item = this.states[this.curState][i];
            if ("input" === item.type) {
                if ("email" === item.kind) {
                    var res = this.extractor.extractData(text, [ "email" ]);
                    res[0] ? this.slots.INPUT = "'" + res[0] + "'" : this.slots.INPUT = null;
                } else if ("phone" === item.kind) {
                    let res = this.extractor.extractData(text, [ "phone" ]);
                    res[0] ? this.slots.INPUT = "'" + res[0] + "'" : this.slots.INPUT = null;
                } else if ("int" === item.kind) {
                    let res = this.extractor.extractData(text, [ "int" ]);
                    this.slots.INPUT = res[0];
                } else if ("float" === item.kind) {
                    let res = this.extractor.extractData(text, [ "float" ]);
                    this.slots.INPUT = res[0];
                } else if ("DDMMYYYY" === item.kind) {
                    let res = this.extractor.extractData(text, [ "DDMMYYYY" ]);
                    res[0] ? this.slots.INPUT = "'" + res[0] + "'" : this.slots.INPUT = null;
                } else if ("MMDDYYYY" === item.kind) {
                    let res = this.extractor.extractData(text, [ "MMDDYYYY" ]);
                    res[0] ? this.slots.INPUT = "'" + res[0] + "'" : this.slots.INPUT = null;
                } else if ("time" === item.kind) {
                    let res = this.extractor.extractData(text, [ "time" ]);
                    res[0] ? this.slots.INPUT = "'" + res[0] + "'" : this.slots.INPUT = null;
                } else "intent" === item.kind && this.nlu && this.runNLU(text);
                this.runActions(item.actions), this.newState.length && (this.curState = this.newState), 
                this.debug.addChangedSlot("INPUT"), this.debug.add("<br>"), this.debug.show(this.curState, this.slots), 
                this.buttons = [], this.checks = [], this.radios = [];
                break;
            }
        }
        setTimeout(this.showState.bind(this), 1);
    }
    runNLU(text) {
        this.debug.add("<b>NLU futures</b>: ");
        var lang, tm = performance.now(), res = this.nlu.intent(text, this.slots.LANGUAGE), tm = performance.now() - tm;
        for (lang in this.nlu.vocabLen) this.debug.add(`${lang}:${this.nlu.vocabLen[lang]}, `);
        if (this.debug.add(`<b>intents</b>: ${Object.keys(this.nlu.futures).length},  ${Math.round(1e3 * tm) / 1e3} ms<br>`), 
        this.slots.INTENT = "UNKNOWN", res.intents.length) {
            0 < res.intents[0].score && (this.slots.INTENT = res.intents[0].intent), this.slots.CONFIDENCE = Math.round(100 * res.intents[0].score);
            for (let i = 0; i < Math.min(3, res.intents.length); i++) {
                this.debug.add(`${Math.round(100 * res.intents[i].score)}: ${res.intents[i].intent}: `);
                for (let j = 0; j < res.futures[i].length; j++) this.debug.add(res.futures[i][j].word + ", ");
                this.debug.add("<br>");
            }
            this.debug.add("<br>");
        }
    }
    isInputActions(state) {
        var items = this.states[state];
        if (items) {
            for (let i = items.length - 1; 0 <= i; i--) {
                var item = items[i];
                if ("input" === item.type) return "actions" in item && 0 !== item.actions.length && !(1 === item.actions.length && "state" in item.actions && !item.actions.state);
            }
            return !1;
        }
    }
    clearTimers(num = -1) {
        for (let i = 0; i < this.timers.length; i++) i != num && clearTimeout(this.timers[i].id);
        this.timers.length = 0;
    }
    addTimer(item) {
        if (!isNaN(item.time)) {
            let time = 100;
            "number" == typeof item.time ? time = item.time : "string" == typeof item.time && item.time.length && !isNaN(item.time) && (time = parseInt(item.time)), 
            time < 100 && (time = 100), this.timers.push({
                id: setTimeout(this.runTimer.bind(this), time, this.timers.length),
                actions: item.actions
            }), this.debug.add(`<span class="blue2">timer</span> add: ${time} ms (id: ${this.timers[this.timers.length - 1].id}, total: ${this.timers.length})<br>`);
        }
    }
    runTimer(i) {
        this.timers.length && (this.debug.clear(), this.debug.add(`<b>timer</b>:  (id: ${this.timers[this.timers.length - 1].id}, i: ${i}, total: ${this.timers.length})<br>`), 
        this.runActions(this.timers[i].actions), this.clearTimers(i), this.debug.show(this.curState, this.slots), 
        this.buttons = [], this.checks = [], this.radios = [], this.newState || (this.newState = this.curState), 
        this.showState(this.newState));
    }
    addText(item) {
        this.content || this.addMessage();
        let text = this.getText(item.text, !0), p;
        p = item.pre ? this.add(this.content, null, "pre") : (text = text.replace(/\n/g, "<br>"), 
        this.add(this.content, null, "p")), text = this.clearTextFromSpecial(text), p.innerHTML = text, 
        void 0 !== item.color && (p.style.color = item.color), item.center && (p.style.textAlign = "center");
    }
    clearTextFromSpecial(text) {
        return text = (text = (text = text.replace(/\\{\\{/g, "{{")).replace(/\\}\\}/g, "}}")).replace(/\\\$/, "$");
    }
    addRow() {
        this.content || this.addMessage(), this.row = this.add(this.content, "qubot-row");
    }
    addButton(rowID, btnID, btn) {
        let text = this.getText(btn.button, !0), button = (text = this.clearTextFromSpecial(text), 
        document.createElement("div"));
        button.className = "button", "check" === btn.kind ? (button.innerHTML = (btn.checked ? "☒&nbsp;" : "☐&nbsp;") + text, 
        this.checks.push({
            item: btn,
            button: button
        })) : "radio" === btn.kind ? (button.innerHTML = (btn.checked ? "◉&nbsp;" : "○&nbsp;") + text, 
        this.radios.push({
            item: btn,
            button: button
        })) : button.innerHTML = text, text = text.replace(/"/g, '\\"'), button.setAttribute("onclick", `qubotManager.buttonPlayer(${this.buttons.length}, ${rowID}, ${btnID}, "${text}")`), 
        this.buttons.push({
            item: btn,
            button: button
        }), "left" === btn.align ? (button.style.justifyContent = "flex-start", button.style.textAlign = "left") : "right" === btn.align && (button.style.justifyContent = "flex-end", 
        button.style.textAlign = "right"), this.row.append(button);
    }
    addImage(image) {
        this.content || this.addMessage();
        var src = image.image;
        this.images || this.appendImages();
        let imageItem = this.add(this.images, "image"), width = image.width, img = (width = width || 100, 
        imageItem.style.width = width + "%", 0 === image.center && (this.images.style.justifyContent = "flex-start"), 
        this.add(imageItem, null, "img"));
        if (img.setAttribute("onload", "qubotManager.gotoBottom()"), img.setAttribute("src", "" + src), 
        image.caption) {
            let cap = this.add(imageItem, "caption");
            cap.innerHTML = this.getText(image.caption);
        }
    }
    appendMap(item) {
        this.content || this.addMessage();
        let map = this.add(this.content, "map");
        map.classList.add("qubot-disable-select");
        var src = item.url.match(/src\s*=\s*".+?"/), item = this.getInt(item.height, 200, 50, 600);
        src && src.length && (map.innerHTML = `<iframe ${src[0]} width="100%" height="${item}" style="border:0;" loading="lazy"></iframe>`);
    }
    appendMedia(item, kind) {
        if (item.url && item.url.length) {
            this.content || this.addMessage();
            let media = this.add(this.content, kind, kind), source = (media.classList.add("qubot-disable-select"), 
            item.play && media.setAttribute("autoplay", "true"), item.control && media.setAttribute("controls", "true"), 
            item.loop && media.setAttribute("loop", "true"), this.medias.push({
                media: media,
                item: item
            }), this.add(media, null, "source"));
            "audio" === kind ? source.type = "audio/mpeg" : "video" === kind && (source.type = "video/mp4"), 
            source.setAttribute("src", item.url);
        }
    }
    stopMedia() {
        for (let i = 0; i < this.medias.length; i++) try {
            this.medias[i].item.stop && this.medias[i].media.pause();
        } catch (e) {}
        this.medias = [];
    }
    addMessage() {
        this.content = this.addBlock("message");
    }
    addAnswer(answer) {
        let buttons = this.chat.getElementsByClassName("qubot-row");
        for (;0 < buttons.length; ) buttons[0].remove();
        if (null != answer) {
            let content = this.addBlock("answer");
            content.innerHTML = answer;
        }
    }
    addBlock(className) {
        var block = this.add(this.chat, className), block = (this.add(block, "logo"), this.add(block, "container")), className = ("message" == className && this.add(block, "sender"), 
        this.add(block, "content"));
        let time = this.add(block, "time"), today = new Date();
        var block = this.strDigit(today.getHours()) + ":" + this.strDigit(today.getMinutes()) + ":" + this.strDigit(today.getSeconds()), tm = this.strDigit(today.getFullYear()) + "-" + this.strDigit(today.getMonth() + 1) + "-" + this.strDigit(today.getDate());
        return time.innerHTML = block + " " + tm, className;
    }
    addTypingBlock() {
        var block = this.add(this.chat, "message");
        this.add(block, "logo");
        return this.add(block, "typing"), block;
    }
    strDigit(d) {
        return d < 10 ? "0" + d : d;
    }
    appendImages() {
        this.content || this.addMessage(), this.images = this.add(this.content, "images");
    }
    clearMessages(cnt) {
        if (!isNaN(cnt) && this.chat) {
            cnt = parseInt(cnt);
            var children = this.chat.children;
            if (-1 === cnt) {
                for (;0 < children.length; ) this.chat.removeChild(this.chat.firstChild);
                this.content = null;
            } else if (0 < cnt) {
                let i = children.length - 1, min = 1;
                for (this.clearThisMessage && (min = 0); children.length > min && 0 <= i && 0 < cnt; ) "message" === children[i].className && cnt--, 
                this.chat.removeChild(children[i]), i--;
                this.content = null;
            } else 0 === cnt && (this.clearThisMessage = !0);
            this.gotoBottom();
        }
    }
    save() {
        if (localStorage) {
            let data = localStorage.getItem("qubotBotsData");
            if (data) try {
                data = JSON.parse(data);
            } catch (e) {
                data = {};
            } else data = {};
            data[this.id] = {
                state: this.curState,
                slots: this.slots,
                close: this.wasClose
            }, localStorage.setItem("qubotBotsData", JSON.stringify(data));
        }
    }
    load() {
        let data = localStorage.getItem("qubotBotsData");
        if (!data) return !1;
        try {
            data = JSON.parse(data);
        } catch (e) {
            data = {};
        }
        return this.id in data && (data = data[this.id], data.slots && (this.slots = data.slots), 
        data.state && (this.curState = data.state), null !== data.close && (this.wasClose = data.close), 
        !0);
    }
    clear() {
        if (this.chat) for (;this.chat.firstChild; ) this.chat.removeChild(this.chat.lastChild);
        for (var slot in this.slots) this.slots[slot] = null, "LANGUAGE" === slot && (this.slots[slot] = "en");
        for (var state in this.curState = this.start, this.checks = [], this.radios = [], 
        this.states) for (let i = 0; i < this.states[state].length; i++) {
            var item = this.states[state][i];
            if ("row" === item.type) for (let j = 0; j < item.items.length; j++) {
                let button = item.items[j];
                "check" !== button.kind && "radio" !== button.kind || (button.checked = !1);
            }
        }
        this.wasClose = !1, this.save();
    }
    beforeClear() {
        this.clearTimers();
        let buttons = this.chat.getElementsByClassName("qubot-row");
        for (;0 < buttons.length; ) buttons[0].remove();
        this.addMessage();
        let p = this.add(this.content, null, "p");
        p.innerHTML = this.getText({
            en: "You are about to clear the chat history.<br>Are you sure?",
            ru: "Вы хотите очистить мою память.<br> Это точно?"
        }, !0);
        var row = this.add(this.content, "qubot-row");
        let btn = this.add(row, "button");
        btn.innerHTML = this.getText({
            en: "✔ Yes",
            ru: "✔ Да"
        }, !0), btn.setAttribute("onclick", "qubotManager.clearYes()"), btn = this.add(row, "button"), 
        btn.innerHTML = this.getText({
            en: "❌ No",
            ru: "❌ Нет"
        }, !0), btn.setAttribute("onclick", "qubotManager.clearNo()"), this.gotoBottom();
    }
    createNLU() {
        performance.now();
        let intents = {};
        for (var state in this.states) {
            var items = this.states[state];
            for (let i = 0; i < items.length; i++) if ("intents" === items[i].type) {
                var actions = items[i].actions;
                if (actions) for (let j = 0; j < actions.length; j++) {
                    var intent = actions[j];
                    if (intent.intent && intent.words) for (var lang in intent.intent in intents || (intents[intent.intent] = {}), 
                    intent.words) intents[intent.intent][lang] ? intents[intent.intent][lang] += " " + intent.words[lang] : intents[intent.intent][lang] = intent.words[lang];
                }
            }
        }
        this.nlu = new QuBotNLU(), this.nlu.intents = intents, this.nlu.learn(), performance.now();
    }
    gotoBottom() {
        let div = document.getElementById("qubot");
        div.scrollTop = div.scrollHeight;
    }
    add(parent, className, element = "div") {
        let block = document.createElement(element);
        return null !== className && (block.className = className), null !== parent && parent.append(block), 
        block;
    }
}

class QuBotActions extends QuBotVisual {
    constructor() {
        super();
    }
    runActions(actions, skip = "    ", last = {
        IF: null,
        SWITCH: null
    }) {
        if (actions) {
            for (let i = 0; i < actions.length && !this.wasGoto; i++) {
                var action = actions[i];
                if ("state" in action) this.runActionState(action, skip); else if ("goto" in action) {
                    if (this.runActionGoto(action, skip)) break;
                } else if ("run" in action) this.runActionRun(action, skip); else if ("slot" in action) this.runActionSlot(action, skip); else if ("clear" in action) this.actionClear(action, skip); else if ("script" in action) {
                    if (this.runActionScript(action.script, skip), this.wasGoto) break;
                } else "if" in action ? last = this.runActionIF(action, skip, last) : "else" in action ? last = this.runActionELSE(action, skip, last) : "switch" in action ? last = this.runActionSwitch(action, skip, last) : "case" in action ? last = this.runActionCase(action, skip, last) : "default" in action ? last = this.runActionDefault(action, skip, last) : "action" in action && (last = this.actionAction(action, skip, last));
            }
            return last;
        }
    }
    checkState(state) {
        return "$" !== state[0] || (state = 1 < (state = this.insertSlots(state)).length && ("'" === state[0] || '"' === state[0]) ? state.substring(1, state.length - 1) : state) in this.states ? state : (this.debug.add(skip + `<span class='red'>Unknown step name </span>: ${state}<br>`), 
        "");
    }
    runActionState(action, skip) {
        var state;
        action.state && (state = this.removeQuotes(action.state), this.debug.add(skip + `<span class='blue2'>step</span> ${state} `), 
        (state = this.checkState(state)) && (this.newState = state, this.removeQuotes(action.state) === state ? this.debug.add(skip + "<br>") : this.debug.add(skip + `<span class="small">= ${state}</span><br>`)));
    }
    runActionGoto(action, skip) {
        if (!action.goto) return !1;
        var action = this.removeQuotes(action.goto), state = (this.debug.add(skip + `<span class='blue2'>goto</span> ${action} `), 
        action);
        return (state = this.checkState(state)) ? (this.newState = state, this.wasGoto = !0, 
        action === state ? this.debug.add(skip + "<br>") : this.debug.add(skip + `<span class="small">= ${state}</span><br>`), 
        !0) : void 0;
    }
    runActionRun(action, skip) {
        var state;
        action.run && (state = this.removeQuotes(action.run), this.debug.add(skip + `<span class='blue2'>run</span> ${state} `), 
        (state = this.checkState(state)) && (this.removeQuotes(action.state) === state ? this.debug.add(skip + "<br>") : this.debug.add(skip + `<span class="small">= ${state}</span><br>`), 
        action = this.curState, skip = this.itemID, this.itemID = 0, this.showStateItems(this.states[state]), 
        this.curState = action, this.itemID = skip));
    }
    runActionSlot(action, skip = "") {
        let slot = action.slot, val = action.value;
        if (this.debug.add(skip + '<span class="blue2">slot</span> ' + slot + " = " + val), 
        "LANGUAGE" === slot) return val = val.replace(/'/g, ""), val = val.replace(/"/g, ""), 
        2 !== val.length && this.debug.add(skip + '<br>    <span class="red">Wrong name of language (must be 2 letter)</span><br>'), 
        this.slots[slot] = val, void this.debug.addChangedSlot(slot);
        val = this.evalText(action.value), this.slots[slot] = val, val != this.removeQuotes(action.value) ? this.debug.add(" = <span class='small'>" + val + "</span><br>") : this.debug.add("<br>"), 
        this.debug.addChangedSlot(slot);
    }
    runActionIF(action, skip, last) {
        var cond = this.evalText(action.if);
        return this.debug.add(skip + '<b class="blue2">if</b>  (' + action.if + ") = "), 
        cond ? (this.debug.add("<b class='green'>" + cond + "</b><br>"), this.runActions(action.actions, skip + "    ")) : this.debug.add("<b class='red'>" + cond + "</b><br>"), 
        {
            IF: cond,
            SWITCH: last.SWITCH
        };
    }
    runActionELSE(action, skip, last) {
        var cond, elif = action.else.trim();
        return last.IF ? {
            IF: !0,
            SWITCH: last.SWITCH
        } : 0 < elif.length ? (cond = this.evalText(elif), this.debug.add(skip + '<b class="blue2">elif</b>(' + elif + ") = "), 
        cond ? (this.debug.add("<b class='green'>" + cond + "</b><br>"), this.runActions(action.actions, skip + "    ")) : this.debug.add("<b class='red'>" + cond + "</b><br>"), 
        {
            IF: cond,
            SWITCH: last.SWITCH
        }) : (this.debug.add(skip + "<b class='blue2'>else:</b><br>"), this.runActions(action.actions, skip + "    "), 
        {
            IF: !0,
            SWITCH: last.SWITCH
        });
    }
    runActionSwitch(action, skip, last) {
        var SWITCH = action.switch.trim();
        return 0 < SWITCH.length ? (SWITCH = this.evalText(SWITCH), this.debug.add(skip + '<b class="blue2">switch</b>(' + action.switch + ") = "), 
        this.debug.add("<b class='small'>" + SWITCH + "</b><br>"), last = {
            IF: last.IF,
            SWITCH: SWITCH
        }, this.runActions(action.actions, skip + "    ", last)) : {
            IF: last.IF,
            SWITCH: null
        };
    }
    runActionCase(action, skip, last) {
        if (null === last.SWITCH) return last;
        let CASES = action.case.trim().split(";");
        if (0 === CASES.length) return last;
        for (let i = 0; i < CASES.length; i++) {
            var CASE = CASES[i].trim(), cond = this.evalText(CASE) == last.SWITCH;
            if (this.debug.add(skip + '<b class="blue2">case</b>(' + CASE + ") = "), cond) {
                this.debug.add("<b class='green'>" + cond + "</b><br>"), (last = this.runActions(action.actions, skip + "    ", last)).SWITCH = null;
                break;
            }
            this.debug.add("<b class='red'>" + cond + "</b><br>");
        }
        return last;
    }
    runActionDefault(action, skip, last) {
        return null !== last.SWITCH && (this.debug.add(skip + '<b class="blue2">default:</b><br>'), 
        (last = this.runActions(action.actions, skip + "    ", last)).SWITCH = null), last;
    }
    actionClear(action, skip) {
        action.clear && (this.debug.add(skip + "<span class='blue2'>clear</span>: " + action.clear + "<br>"), 
        this.clearMessages(action.clear));
    }
    actionAction(action, skip, last) {
        return "save" === action.action && (action.storage || (action.storage = "wp"), this.debug.add(skip + '<span class="blue2">save</span>: ' + action.storage + ` = {${action.key}: ${action.value}}<br>`), 
        qubotData.send(action.storage, 1, this.id, this.uid, this.evalText(action.value))), 
        "event" === action.action && (this.debug.add(skip + '<span class="blue2">event</span>: ' + action.value), 
        this.events.push(action.key, action.target)), last;
    }
    getText(obj) {
        obj = this.getTextFromObject(obj), obj = this.insertSlots(obj, !0);
        return this.insertExpressions(obj);
    }
    evalText(st) {
        if (st && 0 === (st = st.trim()).length) return null;
        st = this.convertPythonToJS(st), st = this.insertSlots(st);
        let res = 0;
        try {
            res = this.evalTextFunction(st)();
        } catch (e) {
            this.debug.add(`<br><span class="red">Can not eval</span>: ${st}<br>`);
        }
        return res;
    }
    convertPythonToJS(st) {
        let beg = 0, js = "", regex = /".*?"/g;
        for (let i = 0; i < 1e4; i++) {
            var res = regex.exec(st);
            if (!res) {
                let prx = st.substring(beg, st.length);
                js += this.convertPython(prx);
                break;
            }
            var prx = st.substring(beg, regex.lastIndex - res[0].length);
            this.convertPython(prx), js += prx + res[0], beg = regex.lastIndex;
        }
        return js;
    }
    convertPython(st) {
        return st = (st = (st = (st = (st = (st = (st = (st = st.replace(/\blen\s*\(\s*(\$\w+)\s*\)/g, "$1.length")).replace(/\bfloor\s*\(\s*(\$\w+|[+-]?\d+(\.\d*)?)\s*\)/g, "Math.floor($1)")).replace(/\bceil\s*\(\s*(\$\w+|[+-]?\d+(\.\d*)?)\s*\)/g, "Math.ceil($1)")).replace(/\brandom\s*\(\s*\)/g, " Math.random()")).replace(/\brandint\s*\(\s*(\$\w+|\d+|\$\w+\s*[+-]\s*\d+)\s*,\s*(\$\w+|\d+|\$\w+\s*[+-]\s*\d+)\s*\)/g, " $1 + Math.floor(Math.random()*( $2 - $1 + 1))")).replace(/\band\b/g, " && ")).replace(/\bor\b/g, " || ")).replace(/\bnot\b/g, " ! ");
    }
    insertExpressions(st) {
        let arr = st.match(/{{(.*?)}}/g);
        if (arr) for (let i = 0; i < arr.length; i++) {
            var val = this.evalText(arr[i].substring(2, arr[i].length - 2));
            st = st.replace(arr[i], val);
        }
        return st.replace(/\\$/g, "$");
    }
    evalTextFunction(st) {
        return Function("return " + st + ";");
    }
    getTextFromObject(obj, noCommas = 0) {
        let res = "";
        if ("string" == typeof obj) res = obj; else if (this.slots.LANGUAGE in obj) res = obj[this.slots.LANGUAGE]; else for (var k in obj) {
            res = obj[k];
            break;
        }
        return res;
    }
    getInt(text, def, min, max) {
        let val = def;
        try {
            val = parseInt(text);
        } catch (e) {
            val = def;
        }
        return val < min && (val = min), val > max && (val = max), val;
    }
    removeQuotes(txt) {
        return txt && txt.length && ("'" === txt[0] && "'" === txt[txt.length - 1] || '"' === txt[0] && '"' === txt[txt.length - 1]) ? txt.substring(1, txt.length - 1) : txt;
    }
    insertSlots(st, noCommas = !1) {
        let beg = 0, start = 0, result = "";
        for (let cnt = 0; cnt < 1e5; cnt++) {
            let pos1 = st.indexOf("$", beg), pos2;
            if (pos1 < 0) break;
            if (0 < pos1 && "\\" === st[pos1 - 1]) beg = pos1 + 1; else {
                let regex = /\$(\w+)/g, res = (regex.lastIndex = pos1, regex.exec(st));
                if (res) {
                    var slot = res[1];
                    if (pos2 = regex.lastIndex, pos2 < st.length) if ("[" === st[pos2]) {
                        if (regex = /\[\s*(.+?)\s*\]/g, regex.lastIndex = pos2, res = regex.exec(st), res) {
                            var indx = this.evalText(res[1]);
                            beg = pos2 = regex.lastIndex;
                            let val = this.getArrayValue(slot, indx, noCommas);
                            pos2 < st.length && "." === st[pos2] && this.isDict(val) && (regex = /\.(\w+)/g, 
                            regex.lastIndex = pos2, res = regex.exec(st), res && (beg = pos2 = regex.lastIndex, 
                            val = val[res[1]], val = this.getScalarValueIfString(val, noCommas))), result += st.substring(start, pos1) + val, 
                            start = pos2;
                            continue;
                        }
                    } else if ("." === st[pos2] && (regex = /\.(\w+)/g, regex.lastIndex = pos2, res = regex.exec(st), 
                    res && "length" !== res[1])) {
                        beg = pos2 = regex.lastIndex;
                        let val = this.getObjectValue(slot, res[1], noCommas);
                        val = this.getScalarValueIfString(val, noCommas), result += st.substring(start, pos1) + val, 
                        start = pos2;
                        continue;
                    }
                    beg = pos2;
                    indx = this.getScalarValue(slot, noCommas);
                    result += st.substring(start, pos1) + indx, start = pos2;
                } else beg = pos1 + 1;
            }
        }
        return result += st.substring(start), result;
    }
    getArrayValue(slot, index, noCommas) {
        slot = this.getSlotValue(slot);
        if (Array.isArray(slot)) {
            try {
                index = parseInt(index);
            } catch (e) {
                return;
            }
            let res = null;
            return 0 <= index && index < slot.length && (res = slot[index]), index < 0 && 0 <= slot.length + index && (res = slot[slot.length + index]), 
            noCommas || this.isDict(res) || (res = '"' + res + '"'), res;
        }
    }
    getObjectValue(slot, key, noCommas) {
        slot = this.getSlotValue(slot, noCommas);
        if (this.isDict(!slot) && key in slot) {
            let res = slot.key;
            return res && !noCommas && (res = '"' + res + '"'), res;
        }
    }
    getScalarValue(slot, noCommas) {
        let val = this.getSlotValue(slot);
        return val = Array.isArray(val) ? "[" + val + "]" : this.getScalarValueIfString(val, noCommas), 
        val;
    }
    getScalarValueIfString(val, noCommas) {
        if ("string" == typeof val) {
            if (noCommas) return this.removeQuotes(val);
            val = '"' + (val = this.removeQuotes(val)) + '"';
        }
        return val;
    }
    getSlotValue(slot) {
        let val;
        return slot in this.localSlots ? val = this.localSlots[slot] : slot in this.slots && (val = this.slots[slot]), 
        val;
    }
    isDict(obj) {
        return obj && "object" == typeof obj && !Array.isArray(obj);
    }
}

class QuBotDebug {
    constructor() {
        this.debugInfo = "", this.changedSlots = {};
    }
    create(state) {
        if (!document.getElementById("qubot-debug")) {
            this.debugWindow = this.div(document.body, "qubot-debug"), this.debugWindow.id = "qubot-debug", 
            this.debugHeader = this.div(this.debugWindow, "header"), this.debugHeader.onmousedown = this.mousedownDebug.bind(this);
            let close = this.div(this.debugHeader, "close-button", "span");
            close.innerHTML = "&times;", close.setAttribute("onclick", "this.parentNode.parentNode.remove()"), 
            this.debugState = this.div(this.debugHeader, null, "span"), this.debugState.innerHTML = state;
            state = this.div(this.debugWindow, "content");
            this.debugSlots = this.div(state, "slots"), this.debugDebug = this.div(state, "debug"), 
            this.clear();
        }
    }
    clear() {
        this.debugInfo = "", this.changedSlots = {}, this.debugState && (this.debugState.innerHTML = ""), 
        this.debugDebug && (this.debugDebug.innerHTML = ""), this.debugSlots && (this.debugSlots.innerHTML = "");
    }
    add(info) {
        this.debugInfo += info;
    }
    addChangedSlot(slot) {
        this.changedSlots[slot] = 1;
    }
    show(state, slots) {
        if (document.getElementById("qubot-debug")) {
            this.debugState.innerHTML = state;
            let res = "<table>";
            for (var slot in slots) {
                var val = slots[slot] ? JSON.stringify(slots[slot]) : null;
                slot in this.changedSlots ? res += `<tr><td>${slot}</td><td class="red">${val}</td></tr>` : res += `<tr><td>${slot}</td><td>${val}</td></tr>`;
            }
            res += "</table>", this.debugSlots.innerHTML = res, this.debugDebug.innerHTML = "<pre>" + this.debugInfo + "</pre>";
        }
    }
    mousedownDebug(e) {
        e.stopPropagation(), this.mousePosX = e.clientX, this.mousePosY = e.clientY, this.debugWindow.style.left = this.debugWindow.offsetLeft + "px", 
        this.debugWindow.style.top = this.debugWindow.offsetTop + "px", document.onmouseup = this.mouseupDebug.bind(this), 
        document.onmousemove = this.mousemoveDebug.bind(this);
    }
    mousemoveDebug(e) {
        e.stopPropagation();
        var dX = this.mousePosX - e.clientX, dY = this.mousePosY - e.clientY;
        0 < this.debugWindow.offsetLeft - dX && (this.mousePosX = e.clientX, this.debugWindow.style.left = this.debugWindow.offsetLeft - dX + "px"), 
        0 < this.debugWindow.offsetTop - dY && (this.mousePosY = e.clientY, this.debugWindow.style.top = this.debugWindow.offsetTop - dY + "px");
    }
    mouseupDebug(e) {
        e.stopPropagation(), document.onmouseup = null, document.onmousemove = null;
    }
    div(parent, className, element = "div") {
        let block = document.createElement(element);
        return null !== className && (block.className = className), null !== parent && parent.append(block), 
        block;
    }
}

class QuBotExtractor {
    constructor() {
        this.regexs = {
            int: /([+-]?\b(?:0|[1-9]\d*))\b/,
            float: /[+-]?\b\d+(?:\.\d*)?(?:[eE][+-]?\d+)?\b/,
            email: /\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Z|a-z]{2,}\b/,
            http: /\b[A-Za-z0-9._-]+\.[A-Z|a-z]{2,4}[/\?A-Za-z0-9._-|%|\=]*\b/,
            phone: /(?:[\(]?[ ]?\d[ \-\.\)]?){10,12}(?![\w%&@\-])/,
            date1: /\b(\d{1,2})[\/\-\.](\d{1,2})[\/\-\.](\d{4})\b/,
            date2: /\b(\d{4})[\/\-\.](\d{1,2})[\/\-\.](\d{1,2})\b/,
            time: /\b(\d{1,2})[:\-\.](\d{1,2})([:\-\.](\d{1,2}))?\b/
        };
    }
    extractData(text, args) {
        let res = [];
        for (var i in args) {
            i = args[i];
            if ("DDMMYYYY" === i) this.extractDate(text, res); else if ("MMDDYYYY" === i) this.extractDate(text, res, !1); else if ("time" === i) this.extractTime(text, res); else if (i in this.regexs) {
                var arr = this.regexs[i].exec(text);
                if (null == arr) res.push(null); else {
                    let val = arr[0];
                    "int" === i ? val = parseInt(val) : "float" === i && (val = parseFloat(val)), res.push(val);
                }
            } else res.push(null);
        }
        return res;
    }
    extractDate(text, res, dayFirst = !0) {
        let arr = this.regexs.date1.exec(text), dd, mm, yyyy;
        if (arr ? (dd = parseInt(arr[1]), mm = parseInt(arr[2]), yyyy = parseInt(arr[3])) : (arr = this.regexs.date2.exec(text), 
        arr && (yyyy = parseInt(arr[1]), dd = parseInt(arr[2]), mm = parseInt(arr[3]))), 
        arr) {
            if (dayFirst || (text = mm, mm = dd, dd = text), 12 < mm && dd <= 12) {
                let t = mm;
                mm = dd, dd = t;
            }
            dd < 1 || 31 < dd || mm < 1 || 12 < mm ? res.push(null) : (dd = dd < 10 ? "0" + dd : "" + dd, 
            mm = mm < 10 ? "0" + mm : "" + mm, res.push(yyyy + "-" + mm + "-" + dd));
        } else res.push(null);
    }
    extractTime(text, res) {
        text = this.regexs.time.exec(text);
        if (text && 2 < text.length) {
            let hh = parseInt(text[1]), mm = parseInt(text[2]);
            24 < hh || 59 < mm ? res.push(null) : (hh = hh < 10 ? "0" + hh : "" + hh, mm = mm < 10 ? "0" + mm : "" + mm, 
            res.push(hh + ":" + mm));
        } else res.push(null);
    }
}

class QuBotEvents {
    constructor(botID) {
        var data;
        this.bid = null, this.uid = null, this.lid = 1, this.delay = 1e5, !localStorage || (data = localStorage.getItem("qubotLID")) && (this.lid = parseInt(data)), 
        this.events = [];
    }
    init(bid, uid) {
        this.bid = bid, this.uid = uid, setTimeout(this.timer.bind(this), this.delay);
    }
    push(name, target = !1, params = null) {
        if (this.bid && qubotData.isToken) {
            let event = {
                name: name,
                time: new Date().getTime(),
                uid: this.uid,
                bid: this.bid,
                cid: qubotData.cid,
                lid: this.lid
            };
            params && (event.params = params), target && (event.target = target), this.lid++, 
            this.events.push(event);
        }
    }
    clear() {
        this.events = [];
    }
    timer() {
        this.send(), setTimeout(this.timer.bind(this), this.delay);
    }
    send() {
        if (this.events.length) {
            localStorage && localStorage.setItem("qubotLID", this.lid), qubotData.sendAnalytics({
                request: "addEvents",
                events: this.events
            });
            this.events = [];
        }
    }
}

class QuBot extends QuBotActions {
    constructor() {
        super();
    }
    runActionScript(st, skip = "") {
        let res = {
            end: 0
        };
        for (;;) {
            if (res = this.parseFun(st, res.end, st.length), !res) break;
            if ("text" === res.name) this.runScriptText(res.args, skip); else if ("images" === res.name) this.runScriptImages(res.args, skip); else if ("image" === res.name) this.runScriptImage(res.args, skip); else if ("get_check" === res.name) this.runScriptGetCheck(res.args, skip); else if ("set_check" === res.name) this.runScriptSetCheck(res.args, skip); else if ("get_radio" === res.name) this.runScriptGetRadio(res.args, skip); else if ("set_radio" === res.name) this.runScriptSetRadio(res.args, skip); else if ("set" === res.name) this.runScriptSet(res.args, skip); else if ("step" === res.name) this.runScriptStep(res.args, skip); else if ("goto" === res.name) {
                if (this.runScriptGoto(res.args, skip), this.wasGoto) break;
            } else "if" === res.name ? this.runScriptIf(res.args, skip) : "while" === res.name ? this.runScriptWhile(res.args, skip) : "clear" === res.name ? this.runScriptClear(res.args, skip) : "len" === res.name ? this.runScriptLen(res.args, skip) : "push" === res.name ? this.runScriptPush(res.args, skip) : "get" === res.name ? this.runScriptGet(res.args, skip) : "sum" === res.name ? this.runScriptSum(res.args, skip) : "remove" === res.name ? this.runScriptRemove(res.args, skip) : "add" === res.name ? this.runScriptAdd(res.args, skip) : "total" === res.name ? this.runScriptTotal(res.args, skip) : "foreach" === res.name ? this.runScriptForeach(res.args, skip) : this.debug.add(`<br><span class="red">Unknown script function ${res.name}</span><br>`);
        }
    }
    checkFunArgs(name, args, min, max, skip, br = "<br>") {
        if (args.length < min || args.length > max) return this.debug.add(skip + `<span class='blue2'>${name}</span>: <span class='red'>Wrong count = ${args.length} of args (expect in [${min},${max}])</span><br>`), 
        !1;
        if (this.debug.add(skip + `<span class='blue2'>${name}</span>: `), args.length) {
            let lines = args[0].trim().split("\n");
            1 < lines.length && this.debug.add("<br>");
            for (let i = 0; i < lines.length; i++) {
                let st = lines[i].replace(/(<br>)/gi, "&lt;br&gt;");
                1 === lines.length ? this.debug.add(st.trim()) : this.debug.add(skip + st), 1 < lines.length && i + 1 < lines.length && this.debug.add("<br>");
            }
        }
        return this.debug.add("" + br), !0;
    }
    runScriptSet(args, skip) {
        var val;
        this.checkFunArgs("set", args, 2, 2, skip, "") && (skip = args[0], val = args[1], 
        val = this.evalText(val), skip in this.localSlots ? this.localSlots[skip] = val : this.slots[skip] = val, 
        this.debug.add(` = ${args[1]} <span class='small'> = ${val}</span><br>`));
    }
    runScriptStep(args, skip) {
        this.checkFunArgs("step", args, 1, 1, skip, "") && (skip = args[0], skip = this.evalText(skip), 
        this.newState = skip, this.debug.add(`<span class='small'> = ${skip}</span><br>`));
    }
    runScriptGoto(args, skip) {
        this.checkFunArgs("goto", args, 1, 1, skip, "") && (skip = args[0], skip = this.evalText(skip), 
        this.newState = skip, this.wasGoto = !0, this.debug.add(`<span class='small'> = ${skip}</span><br>`));
    }
    runScriptIf(args, skip) {
        var cond;
        this.checkFunArgs("if", args, 2, 3, skip, "") && (cond = args[0], cond = this.evalText(cond), 
        this.debug.add(skip + "    " + ` ${cond}<br>`), cond ? this.runActionScript(args[1], skip + "    ") : 3 === args.length && this.runActionScript(args[2], skip + "    "));
    }
    runScriptWhile(args, skip) {
        if (this.checkFunArgs("while", args, 2, 2, skip)) for (let i = 0; i < 1e3; i++) {
            if (!this.evalText(args[0])) break;
            this.runActionScript(args[1], skip + "    ");
        }
    }
    runScriptText(args, skip) {
        if (this.checkFunArgs("text", args, 1, 1, skip)) {
            let text = this.removeQuotes(args[0]).trim();
            4 < text.length && "{" === text[0] && "{" !== text[1] && "}" === text[text.length - 1] && "}" !== text[text.length - 2] && (text = this.evalText(text)), 
            text = text || "", this.addText({
                text: text
            });
        }
    }
    runScriptImages(args, skip) {
        this.checkFunArgs("images", args, 0, 0, skip) && this.appendImages();
    }
    runScriptImage(args, skip) {
        if (this.checkFunArgs("image", args, 1, 2, skip)) {
            skip = this.evalText(args[0]);
            let image = {
                image: this.removeQuotes(skip)
            };
            1 < args.length && (image.width = this.evalText(args[1])), this.addImage(image);
        }
    }
    runScriptGetCheck(args, skip) {
        if (this.checkFunArgs("get_check", args, 1, 1, skip)) {
            let list = this.slots[args[0]];
            Array.isArray(list) || (list = this.slots[args[0]] = []);
            for (let i = list.length = 0; i < this.checks.length; i++) list.push(this.checks[i].item.checked ? 1 : 0);
        }
    }
    runScriptSetCheck(args, skip) {
        if (this.checkFunArgs("set_check", args, 1, 1, skip)) {
            var list = this.slots[args[0]];
            if (Array.isArray(list)) {
                var count = Math.min(list.length, this.checks.length);
                for (let i = 0; i < count; i++) this.checks[i].item.checked = list[i] ? 1 : 0, this.checks[i].button.innerHTML = (this.checks[i].item.checked ? "☒&nbsp;" : "☐&nbsp;") + this.checks[i].button.innerHTML.substring(7);
            } else this.debug.add(skip + "<span class='red'>In heck_set first argument must be list!</span>: <br>");
        }
    }
    runScriptGetRadio(args, skip) {
        if (this.checkFunArgs("get_radio", args, 1, 1, skip)) {
            let list = this.slots[args[0]];
            Array.isArray(list) || (list = this.slots[args[0]] = []);
            for (let i = list.length = 0; i < this.radios.length; i++) list.push(this.radios[i].item.checked ? 1 : 0);
        }
    }
    runScriptSetRadio(args, skip) {
        if (this.checkFunArgs("set_radio", args, 1, 1, skip)) {
            var count = Math.min(list.length, this.radios.length);
            for (let i = 0; i < count; i++) this.radios[i].item.checked = list[i] ? 1 : 0, this.radios[i].button.innerHTML = (this.radios[i].item.checked ? "◉&nbsp;" : "○&nbsp;") + this.radios[i].button.innerHTML.substring(2);
        }
    }
    runScriptClear(args, skip) {
        this.checkFunArgs("clear", args, 1, 1, skip) && (this.slots[args[0]] = []);
    }
    runScriptLen(args, skip) {
        var list;
        this.checkFunArgs("len", args, 2, 2, skip, "") && (list = this.slots[args[0]], Array.isArray(list) ? this.slots[args[1]] = list.length : this.slots[args[1]] = "string" == typeof list ? list.length : 0, 
        this.debug.add(skip + `<span class='small'> <= ${this.slots[args[1]]}</span>: <br>`));
    }
    runScriptPush(args, skip) {
        if (this.checkFunArgs("push", args, 1, 1e3, skip)) {
            args[0] in this.slots && Array.isArray(this.slots[args[0]]) || (this.slots[args[0]] = []);
            let list = this.slots[args[0]];
            for (let i = 1; i < args.length; i++) list.push(this.evalText(args[i]));
        }
    }
    runScriptGet(args, skip) {
        if (this.checkFunArgs("get", args, 3, 3, skip, " ")) {
            if (!(args[0] in this.slots && Array.isArray(this.slots[args[0]]))) return this.slots[args[1]] = null, 
            void this.debug.add(skip + `<span class='red'>Slot ${args[0]} is not list (first argument)</span>:<br>`);
            var list = this.slots[args[0]];
            let index = this.evalText(args[2]);
            if (!isNaN(index) || index >= list.length) return this.slots[args[1]] = null, void this.debug.add(skip + `<span class='red'>Index ${args[2]} = ${index} is not correct index</span>:<br>`);
            if (0 <= index) this.slots[args[1]] = list[index]; else {
                if (index = list.length + index, index < 0) return this.slots[args[1]] = null, void this.debug.add(skip + `<span class='red'>Index ${args[2]} = ${index} is not correct index</span>:<br>`);
                this.slots[args[1]] = list[index];
            }
        }
    }
    runScriptSum(args, skip) {
        if (this.checkFunArgs("sum", args, 2, 2, skip)) {
            args[0] in this.slots && Array.isArray(this.slots[args[0]]) || (this.slots[args[1]] = 0);
            var list = this.slots[args[0]];
            3 === args.length && args[2];
            let res = 0;
            for (let i = 0; i < list.length; i++) {
                var v = list[i];
                isNaN(v) || (res += v);
            }
            this.slots[args[1]] = res;
        }
    }
    runScriptRemove(args, skip) {
        if (this.checkFunArgs("remove", args, 2, 2, skip, "")) {
            var slot = args[0];
            if (slot in this.slots) {
                let list = this.slots[slot];
                Array.isArray(list) ? (args = this.evalText(args[1])) < 0 || args >= list.length ? this.debug.add(skip + `<span class='red'>Wrong index</span>: ${args} (list size = ${list.length})<br>`) : list.splice(args, 1) : this.debug.add(skip + `<span class='red'>Slot ${slot} is not list (first argument)</span>:<br>`);
            } else this.debug.add(skip + `<span class='red'>Unknown slot</span>: ${slot}<br>`);
        }
    }
    runScriptTotal(args, skip) {
        if (this.checkFunArgs("total", args, 2, 3, skip, "")) {
            var list = this.slots[args[0]], slot = args[1];
            if (!Array.isArray(list)) return this.slots[list] = [], void (this.slots[slot] = 0);
            let tot = 0;
            if (2 === args.length) for (let i = 0; i < list.length; i++) {
                var item = list[i];
                item && "object" != typeof item && (tot += item);
            } else for (let i = 0; i < list.length; i++) {
                this.localSlots = {};
                let item = list[i];
                if (this.isDict(item)) {
                    for (var k in item) this.localSlots[k] = item[k];
                    let res = this.removeQuotes(args[2]);
                    try {
                        res = this.evalText(res), res = parseFloat(res), tot += res;
                    } catch (e) {
                        this.debug.add(`<br><span class="red">Can not eval total:</span> ${res}<br>`);
                    }
                }
            }
            this.slots[slot] = tot, this.localSlots = {}, this.debug.add(skip + `<span class='small'> <= ${tot}</span>: <br>`);
        }
    }
    runScriptAdd(args, skip) {
        if (this.checkFunArgs("add", args, 4, 5, skip, "")) {
            var slot = args[0];
            slot in this.slots && Array.isArray(this.slots[slot]) || (this.slots[slot] = []);
            let list = this.slots[slot];
            var slot = args[args.length - 1], agrg = this.parseList(args[1]);
            if (agrg.length) {
                var keys = this.parseList(args[2]);
                if (keys.length) {
                    let cond = null;
                    if (5 === args.length && (cond = args[3]), !agrg || keys && keys.length && agrg.length) {
                        var val = this.evalText(slot);
                        let wasAggregate = !1;
                        if (agrg) for (let i = 0; i < list.length; i++) {
                            let it = list[i];
                            if ("object" == typeof it) {
                                if (null !== cond) {
                                    for (var k in this.localSlots = {}, it) this.localSlots[k] = it[k];
                                    var res = this.evalText(cond);
                                    if (this.localSlots = {}, !res) continue;
                                }
                                let match = !0;
                                for (let j = 0; j < keys.length; j++) {
                                    let k = keys[j];
                                    if (!(k in it) || it[k] != val[k]) {
                                        match = !1;
                                        break;
                                    }
                                }
                                if (match) for (let j = 0; j < agrg.length; j++) {
                                    var t = agrg[j];
                                    t in it && t in val && (it[t] += val[t], wasAggregate = !0);
                                }
                            }
                        }
                        wasAggregate || list.push(val), val != slot ? this.debug.add(skip + "    " + `${slot}  = <span class='small'>${JSON.stringify(val)} (aggregate:${wasAggregate})</span><br>`) : this.debug.add(skip + "    " + slot + " <br>");
                    } else this.debug.add(skip + "    <span class='red'>There are keys to aggregate, but no keys to check</span><br>");
                } else this.debug.add(skip + "    <span class='red'>Keys to check (fourth argument) are not a list  or empty</span><br>");
            } else this.debug.add(skip + "    <span class='red'>Aggregation keys (third argument) are not a list or empty</span><br>");
        }
    }
    runScriptForeach(args, skip) {
        if (this.checkFunArgs("foreach", args, 2, 3, skip)) {
            var slot = args[0];
            if (slot in this.slots) {
                Array.isArray(this.slots[slot]) || (this.slots[slot] = []);
                let cond = null;
                3 === args.length && (cond = args[1]);
                var list = this.slots[slot];
                for (let i = 0; i < list.length; i++) {
                    this.localSlots = {};
                    var item = list[i];
                    if (this.isDict(item)) for (var k in item) this.localSlots[k] = item[k];
                    if (null !== cond) if (!this.evalText(cond)) continue;
                    this.localSlots.ITEM_INDEX = i, this.localSlots.ITEM_VALUE = item, this.runActionScript(args[args.length - 1], skip + "    ");
                }
                this.localSlots = {};
            }
        }
    }
    parse(st) {
        st = st.replace(/#.*?\n/g, "");
        let res = {
            end: 0
        };
        for (;;) if (res = this.parseFun(st, res.end, st.length), !res) break;
    }
    parseFun(st, beg, end) {
        let bra = 0, qu = !1, start;
        for (let i = beg; i < end; i++) if ('"' === st[i]) qu = !qu; else if ("(" !== st[i] || qu) {
            if (")" !== st[i] || qu) {
                if (0 == bra && "=" === st[i] && !qu && "=" != st[i + 1]) {
                    start = i + 1;
                    let slotName = st.substring(beg, start - 1).match(/\s*(\w+)\s*$/), end = (slotName = slotName && slotName[1], 
                    start + st.slice(start).search(/\n|$/)), args = this.parseArgs(st, start, end);
                    return {
                        beg: start,
                        end: end,
                        name: "set",
                        args: [ slotName, args[0] ]
                    };
                }
            } else if (bra--, 0 === bra) {
                let name = st.substring(beg, start).match(/\s*(\w+)\s*$/);
                name = name && name[1];
                var args = this.parseArgs(st, start + 1, i);
                return {
                    beg: start,
                    end: i + 1,
                    name: name,
                    args: args
                };
            }
        } else bra++, 1 === bra && (start = i);
        return bra && this.debug.add("<span class='red'>No close bracket ) </span><br>"), 
        null;
    }
    parseArgs(st, beg, end) {
        let bra = 0, qu = !1, bra2 = 0, bra3 = 0, start = beg, args = [];
        for (let i = beg; i < end; i++) '"' === st[i] ? qu = !qu : "{" === st[i] ? bra2++ : "}" === st[i] ? bra2-- : "[" === st[i] ? bra3++ : "]" === st[i] ? bra3-- : "(" !== st[i] || qu ? ")" !== st[i] || qu ? "," !== st[i] || qu || bra2 || bra3 || 0 === bra && (args.push(st.substring(start, i).trim()), 
        start = i + 1) : bra-- : bra++;
        return bra && this.debug.add("<span class='red'>No close bracket ) </span><br>"), 
        bra2 && this.debug.add("<span class='red'>No close bracket } </span><br>"), bra3 && this.debug.add("<span class='red'>No close bracket ] </span><br>"), 
        (st = st.substring(start, end).trim()).length && args.push(st), args;
    }
    parseList(st) {
        let res = [];
        if ((st = st.trim()).length < 3 || "[" !== st[0] || "]" !== st[st.length - 1]) return [];
        let ar = (st = st.substring(1, st.length - 1)).split(",");
        for (let i = 0; i < ar.length; i++) {
            var v = ar[i].trim();
            v.length && res.push(v);
        }
        return res;
    }
}

class QuBotManager {
    constructor() {
        this.bots = {}, this.bot = new QuBot(), localStorage && (this.userID = localStorage.getItem("qubotUID"), 
        this.userID || (this.userID = this.uidGenerator(), localStorage.setItem("qubotUID", this.userID)));
    }
    uidGenerator(a = null) {
        return a ? (a ^ 16 * Math.random() >> a / 4).toString(16) : ("10000000100040008000" + 1e11).replace(/[018]/g, this.uidGenerator);
    }
    add(id, bot) {
        this.bot = this.bots[id] = bot;
    }
    div(parent, className, element = "div") {
        let block = document.createElement(element);
        return block.className = className, (null !== parent ? parent : document.body).append(block), 
        block;
    }
    set(bot) {
        this.bot.set(bot, this.userID);
    }
    create(bot) {
        bot && this.set(bot);
        let old = document.getElementById("qubot"), btn = (old && old.remove(), this.div(null, "qubot-open")), wrapper = (btn.id = "qubot-open", 
        btn.setAttribute("onclick", "qubotManager.open();"), this.div(null, "qubot"));
        wrapper.id = "qubot-wrapper";
        var bot = this.div(wrapper, "header"), body = this.div(wrapper, "body"), footer = this.div(wrapper, "footer");
        let chat = this.div(body, "chat");
        chat.id = "qubot";
        body = this.div(bot, "content");
        this.div(body, "logo"), this.div(body, "name");
        let reload = this.div(body, "reload"), close = this.div(body, "close");
        this.div(bot, "info");
        body = this.div(footer, "content"), bot = this.div(body, "container");
        let input = this.div(bot, "input", "input"), send = (input.id = "qubot-input", this.div(bot, "send"));
        reload.onclick = this.beforeClear.bind(this), close.onclick = this.close.bind(this), 
        send.onclick = this.input.bind(this), input.setAttribute("onkeypress", "qubotManager.bot.inputEnter(event)");
    }
    start(restart, lang = "en") {
        if (this.bot) {
            if (localStorage) {
                let data = localStorage.getItem("qubotBotsUID");
                data ? (data = JSON.parse(data), this.bot.id in data || (data[this.bot.id] = 1, 
                localStorage.setItem("qubotBotsUID", JSON.stringify(data)), this.addUsersEvent())) : (data = {}, 
                data[this.bot.id] = 1, localStorage.setItem("qubotBotsUID", JSON.stringify(data)), 
                this.addUsersEvent());
            }
            document.getElementById("qubot").innerHTML = "", this.bot.START_STATE(restart, lang);
        }
    }
    addUsersEvent() {
        qubotData.sendAnalytics({
            request: "addUsers",
            users: [ {
                time: new Date().getTime(),
                uid: this.userID,
                bid: this.bot.id,
                cid: qubotData.cid
            } ]
        });
    }
    addBotEvent(bid, name) {
        qubotData.sendBotManager({
            request: "bot_add_plugin",
            bid: bid,
            name: name
        });
    }
    renameBotEvent(bid, name) {
        qubotData.sendBotManager({
            request: "bots_update",
            bots: [ {
                id: bid,
                name: name
            } ]
        });
    }
    open() {
        if (this.bot) {
            this.bot.curState || this.start(), this.bot.wasClose = !1;
            let wrap = document.getElementById("qubot-wrapper"), open = document.getElementById("qubot-open");
            wrap.classList.add("show"), wrap.classList.remove("hide"), open.classList.add("hide"), 
            open.classList.remove("show"), this.gotoBottom(), document.getElementById("qubot-input").focus();
        }
    }
    close() {
        this.bot.wasClose = !0, this.bot.save();
        let wrap = document.getElementById("qubot-wrapper"), open = document.getElementById("qubot-open");
        if (wrap && open) {
            wrap.classList.remove("show"), wrap.classList.add("hide"), open.classList.remove("hide"), 
            open.classList.add("show");
            let div = document.getElementById("qubot-debug");
            div && div.remove();
        }
    }
    gotoBottom() {
        this.bot && this.bot.gotoBottom();
    }
    nextState() {
        return this.bot.nextState;
    }
    input(event) {
        this.bot.input(event);
    }
    button(id, text) {
        this.bot["bt_" + id]("" + text);
    }
    buttonPlayer(btnIndex, rowID, btnID) {
        this.bot.runButton(btnIndex, rowID, btnID);
    }
    beforeClear() {
        this.bot.beforeClear();
    }
    clearYes() {
        this.bot.clear(), this.bot.showState(this.bot.start);
    }
    clearNo() {
        let buttons = this.bot.chat.getElementsByClassName("qubot-row");
        for (;0 < buttons.length; ) buttons[0].remove();
        this.bot.showState(this.bot.curState), this.gotoBottom();
    }
    upgradeBotFormat(bot) {
        if (!bot) return bot;
        if (!("cards" in bot)) {
            let stateCards = {};
            for (var state in bot.posFree) state in stateCards || (stateCards[state] = {
                c: 0,
                r: 0,
                x: 0,
                y: 0
            }), stateCards[state].x = bot.posFree[state].x, stateCards[state].y = bot.posFree[state].y;
            for (let state in bot.posGrid) state in stateCards || (stateCards[state] = {
                c: 0,
                r: 0,
                x: 0,
                y: 0
            }), stateCards[state].r = bot.posGrid[state].r, stateCards[state].c = bot.posGrid[state].c;
            bot.cards = {
                states: stateCards,
                folders: {}
            }, delete bot.posFree, delete bot.posGrid;
        }
    }
}

class QuBotNLU {
    constructor() {
        this.intents = {}, this.vocab = null, this.words = null, this.vocabLen = null, this.futures = null, 
        this.ngramWords = 3, this.ngramChars = 3, this.replaces = [ [ /\bisn't\b/, " is not " ], [ /\baren't\b/, " are not " ], [ /\bwasn't\b/, " was not " ], [ /\bweren't\b/, " were not " ], [ /\bdon't\b/, " do not " ], [ /\bdidn't\b/, " did not " ], [ /\bdoesn't\b/, " does not " ], [ /\bhaven't\b/, " have not " ], [ /\bhadn't\b/, " had not " ], [ /\bhasn't\b/, " has not " ], [ /\bcan't\b/, " can not " ], [ /\bmustn't\b/, " must not " ], [ /\bcouldn't\b/, " could not " ], [ /\bcouldn't\b/, " could not " ], [ /\bshouldn't\b/, " should not " ], [ /\bwouldn't\b/, " would not " ], [ /\bneedn't\b/, " need not " ], [ /\bwon't\b/, " will not " ] ];
    }
    createVocab() {
        for (var intent in this.vocab = {}, this.words = {}, this.intents) {
            let examples = this.intents[intent];
            for (var lang in examples) {
                var sents = examples[lang].split(/;+/);
                examples[lang] = [];
                for (let i = 0; i < sents.length; i++) {
                    var tokens = this.tokenize(sents[i]);
                    examples[lang].push(tokens);
                }
            }
        }
        for (let intent in this.intents) {
            var examples = this.intents[intent];
            for (let lang in examples) {
                lang in this.vocab || (this.vocab[lang] = {}, this.words[lang] = []);
                let voc = this.vocab[lang], sents = examples[lang];
                for (let i = 0; i < sents.length; i++) {
                    var words = this.tokensToWords(sents[i]);
                    for (let j = 0; j < words.length; j++) {
                        var w = words[j];
                        w in voc ? voc[w].num++ : voc[w] = {
                            id: 0,
                            num: 1
                        };
                    }
                }
            }
        }
        this.vocabLen = {};
        for (let lang in this.vocab) {
            let voc = this.vocab[lang], wrds = this.words[lang], id = 0;
            for (let w in voc) voc[w].id = id, wrds.push(w), id++;
            this.vocabLen[lang] = id;
        }
    }
    tokensToWords(words) {
        let res = [];
        for (let i = 0; i < words.length; i++) res.push(words[i]);
        for (let n = 1; n < this.ngramWords; n++) for (let i = 0; i < words.length - n; i++) {
            let w = words[i];
            for (let j = 1; j <= n; j++) w += " " + words[i + j];
            res.push(w);
        }
        if (this.ngramChars) for (let i = 0; i < words.length; i++) {
            let word = words[i];
            if (word.length > this.ngramChars) for (let j = 0; j < word.length - this.ngramChars + 1; j++) {
                var w = word.substring(j, j + this.ngramChars), w = (0 == j ? "^" : "~") + w;
                w += j === word.length - this.ngramChars ? "#" : "~", res.push(w);
            }
        }
        return res;
    }
    createFutures() {
        for (var intent in this.futures = {}, this.intents) {
            this.futures[intent] = {};
            var lang, examples = this.intents[intent];
            for (lang in examples) {
                this.futures[intent][lang] = new Array(this.vocabLen[lang]).fill(0);
                let voc = this.vocab[lang], fut = this.futures[intent][lang];
                var sents = examples[lang];
                for (let i = 0; i < sents.length; i++) {
                    var tokens = sents[i], words = this.tokensToWords(tokens);
                    for (let j = 0; j < words.length; j++) {
                        var w = voc[words[j]];
                        fut[w.id] = 1;
                    }
                }
            }
        }
    }
    learn() {
        this.createVocab(), this.createFutures();
    }
    tokenize(st) {
        st = st.toLowerCase();
        for (let i = 0; i < this.replaces.length; i++) st = st.replace(this.replaces[i][0], this.replaces[i][1]);
        let ar = (st = (st = st.replace(/\?/g, " ? ")).replace(/[,;!"]/g, " ")).split(/\s+/);
        for (let i = 0; i < ar.length; i++) 0 === ar[i].length && ar.splice(i, 1);
        return ar;
    }
    isInExamples(tokens, intent, lang = "en") {
        var sentents = this.intents[intent][lang];
        for (let i = 0; i < sentents.length; i++) {
            var sent = sentents[i];
            if (sent.length === tokens.length) {
                let j = 0;
                for (;j < sent.length && sent[j] === tokens[j]; j++);
                if (j >= sent.length) return !0;
            }
        }
        return !1;
    }
    intent(st, lang = "en") {
        if (!(lang in this.vocab)) return "UNKNOWN";
        var intent, tokens = this.tokenize(st);
        let res = [], significant = [], totSum = 0;
        for (intent in this.intents) this.isInExamples(tokens, intent, lang) && (res.push({
            intent: intent,
            score: 1
        }), significant.push([ {
            word: -1,
            score: 1
        } ]), totSum++);
        if (totSum) {
            for (let i = 0; i < res.length; i++) res[i].score /= totSum;
            return {
                intents: res,
                futures: significant
            };
        }
        var words = this.tokensToWords(tokens);
        let fut = new Array(this.vocabLen[lang]).fill(0);
        var voc = this.vocab[lang];
        for (let i = 0; i < words.length; i++) {
            var word = words[i];
            word in voc && (word = voc[word], fut[word.id] = 1);
        }
        for (let intent in this.futures) {
            var f = this.futures[intent][lang];
            let sum = 0;
            for (let i = 0; i < fut.length; i++) sum += fut[i] * f[i];
            totSum += sum, res.push({
                intent: intent,
                score: sum
            });
        }
        res = res.sort(function(a, b) {
            return b.score - a.score;
        });
        for (let i = 0; i < Math.min(3, res.length); i++) {
            let f = this.futures[res[i].intent][lang], words = this.words[lang], signif = [];
            for (let j = 0; j < fut.length; j++) 0 < fut[j] * f[j] && signif.push({
                word: words[j],
                score: fut[j] * f[j]
            });
            significant.push(signif);
        }
        if (totSum) for (let i = 0; i < res.length; i++) res[i].score /= totSum;
        return {
            intents: res,
            futures: significant
        };
    }
}

class QuBotEditorBase {
    constructor() {}
    add(parent, className, element = "div") {
        let block = document.createElement(element);
        return className && className.length && (block.className = className), parent && parent.append(block), 
        block;
    }
    addBtnAdd(obj, onclick, centerX = !1, centerY = !1, dX = 0, dY = 0) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), centerX ? btn.style.left = (obj.clientWidth - btn.clientWidth) / 2 - 1 + dX + "px" : btn.style.right = -6 + dX + "px", 
        btn.style.bottom = centerY ? (obj.clientHeight - btn.clientHeight) / 2 - 1 + dY + "px" : -6 + dY + "px", 
        this.add(btn, "qubot-icon-add"), btn;
    }
    addBtnDel(obj, onclick, dX = 0, dY = 0) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), btn.style.right = -6 + dX + "px", btn.style.top = -6 + dY + "px", 
        this.add(btn, "qubot-icon-del"), btn;
    }
    addBtnUp(obj, onclick, dX = 0, dY = 0) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), btn.style.top = -6 + dY + "px", btn.style.left = -6 + dX + "px", 
        this.add(btn, "qubot-icon-up"), btn;
    }
    addBtnDn(obj, onclick, dX = 0, dY = 0) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), btn.style.bottom = -6 + dY + "px", 
        btn.style.left = -6 + dX + "px", this.add(btn, "qubot-icon-dn"), btn;
    }
    addBtnLf(obj, onclick) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), btn.style.top = "-6px", btn.style.left = "20px", 
        this.add(btn, "qubot-icon-lf"), btn;
    }
    addBtnRt(obj, onclick) {
        let btn = this.add(obj, "qubot-btn");
        return btn.setAttribute("onclick", onclick), btn.style.top = "-6px", btn.style.right = "20px", 
        this.add(btn, "qubot-icon-rt"), btn;
    }
    addDragMenu(obj, forItems = !0, disabled = []) {
        this.forItems = forItems;
        let menu = this.add(obj, "qubot-drag-menu"), drag = (forItems ? menu.classList.add("qubot-drag-menu-item") : menu.classList.add("qubot-drag-menu-action"), 
        this.add(menu, "qubot-icon-drag"));
        obj = this.add(menu, "qubot-btn-plus");
        this.add(obj, "qubot-icon-plus"), this.addAddMenu(obj, disabled);
        let copy = this.add(menu, "qubot-icon-copy"), paste = this.add(menu, "qubot-icon-paste"), del = this.add(menu, "qubot-icon-trash");
        return forItems ? (del.setAttribute("onclick", "qubotEditor.stateEditor.items.deleteItem(this.parentNode.parentNode); qubotEditor.resetEditorAndCard(); qubotEditor.save()"), 
        copy.setAttribute("onclick", "qubotEditor.stateEditor.items.copyItem(this.parentNode.parentNode);"), 
        paste.setAttribute("onclick", "qubotEditor.stateEditor.items.pasteItem(this.parentNode.parentNode);  qubotEditor.resetEditorAndCard(); qubotEditor.save()")) : (del.setAttribute("onclick", "qubotEditor.stateEditor.actions.delAction(this); qubotEditor.save();  qubotEditor.listEditor.showArrows();"), 
        copy.setAttribute("onclick", "qubotEditor.stateEditor.actions.copyAction(this.parentNode.parentNode); "), 
        paste.setAttribute("onclick", "qubotEditor.stateEditor.actions.pasteAction(this.parentNode.parentNode);")), 
        drag.onmousedown = this.mousedownDragMenu.bind(this), menu;
    }
    mousedownDragMenu(e) {
        this.mousePosY = e.clientY;
        var path = e.path || e.composedPath && e.composedPath();
        if (this.dragItem = path[2], !(this.dragItem.parentNode.children.length < 2)) {
            e.stopPropagation(), e.preventDefault();
            let children = this.dragItem.parentNode.children, j = 0;
            for (let i = 0; i < children.length; i++) {
                if (children[i] === this.dragItem) {
                    this.dragCurPos = j;
                    break;
                }
                children[i].id && j++;
            }
            for (let i = this.dragMinPosY = 0; i < children.length; i++) {
                let child = children[i];
                if (child.id) {
                    this.dragStartPos = parseInt(child.id.substring(13));
                    break;
                }
                this.dragMinPosY = child.offsetTop + child.offsetHeight;
            }
            this.dragItem.parentNode.parentNode && this.dragItem.parentNode.parentNode.id && "qubot-actions" !== this.dragItem.parentNode.id && (this.dragMinPosY = 0), 
            this.dragPhantom = document.createElement("div"), this.dragPhantom.id = "qubot-phantom", 
            this.dragPhantom.style.width = this.dragItem.clientWidth + "px", this.dragPhantom.style.height = this.dragItem.clientHeight + "px", 
            this.dragItem.after(this.dragPhantom);
            path = this.dragItem.currentStyle || window.getComputedStyle(this.dragItem), e = (this.dragItemMarginTop = parseInt(path.marginTop), 
            this.dragItem.clientWidth), path = this.dragItem.offsetTop;
            this.dragItem.style.position = "absolute", this.dragItem.style.width = e - 10 + "px", 
            this.dragItem.style.top = path - this.dragItemMarginTop + "px", this.dragItem.style.zIndex = 1e3, 
            this.dragItem.style.border = "1px dashed black", this.dragItem.style.backgroundColor = "white", 
            this.dragItem.style.opacity = "0.8", this.dragItem.firstChild.onmouseleave = this.mousemoveDragMenu.bind(this), 
            document.onmouseup = this.mouseupDragMenu.bind(this), document.onmousemove = this.mousemoveDragMenu.bind(this);
        }
    }
    mousemoveDragMenu(e) {
        e.stopPropagation(), e.preventDefault(), this.dragItem.firstChild.style.display = "flex", 
        this.dragItem.firstChild.style.opacity = "1";
        var dY = this.mousePosY - e.clientY;
        this.forItems ? this.dragItem.offsetTop - this.dragItemMarginTop - dY >= this.dragItem.parentNode.offsetTop - 2 && this.dragItem.offsetTop - this.dragItemMarginTop - dY <= this.dragItem.parentNode.offsetTop + this.dragItem.parentNode.clientHeight && (this.mousePosY = e.clientY, 
        this.dragItem.style.top = this.dragItem.offsetTop - this.dragItemMarginTop - dY + "px", 
        this.getDragPos()) : this.dragItem.offsetTop - this.dragItemMarginTop - dY >= this.dragMinPosY - 2 && this.dragItem.offsetTop - this.dragItemMarginTop - dY <= this.dragItem.parentNode.clientHeight && (this.mousePosY = e.clientY, 
        this.dragItem.style.top = this.dragItem.offsetTop - this.dragItemMarginTop - dY + "px", 
        this.getDragPos());
    }
    getDragPos() {
        var posY = this.dragItem.offsetTop, children = this.dragItem.parentNode.children;
        for (let i = 0; i < children.length; i++) {
            let child = children[i];
            var dY = .5 * child.offsetHeight;
            if (child.offsetTop < posY && posY < child.offsetTop + child.offsetHeight) {
                child.id && "qubot-phantom" !== child.id && (child.offsetTop + dY > posY ? i + 1 < children.length && children[i + 1] === this.dragPhantom && (child.before(this.dragPhantom), 
                console.log("drag 1")) : (child.after(this.dragPhantom), console.log("drag 2")));
                break;
            }
        }
    }
    mouseupDragMenu(e) {
        e.stopPropagation(), e.preventDefault(), document.onmouseup = null, document.onmousemove = null;
        let newPos = 0, j = 0, children = this.dragItem.parentNode.children;
        for (let i = 0; i < children.length; i++) {
            if ("qubot-phantom" === children[i].id) {
                newPos = j;
                break;
            }
            children[i].id && children[i] !== this.dragItem && j++;
        }
        this.forItems ? (e = parseInt(this.dragItem.id.substring(13)), this.items.changeItemPosition(e, newPos)) : this.changeActionPosition(this.dragStartPos, this.dragCurPos, newPos), 
        this.dragItem.firstChild.onmouseleave = null, this.dragItem.firstChild.style = "", 
        this.dragItem = null, this.dragPhantom.remove(), this.dragPhantom = null, qubotEditor.save();
    }
    createAddMenu(obj, list, disabled = []) {
        let menu = this.add(obj, "qubot-menu");
        for (let i = 0; i < list.length; i++) {
            let item = list[i], a;
            var dis = disabled.includes(item[0]);
            a = dis ? this.add(menu, "a-disabled") : this.add(menu, "a"), a.innerHTML = item[0], 
            dis || a.setAttribute("onclick", item[1]);
        }
        return obj.setAttribute("onclick", "qubotEditor.onclickBtnAdd(this)"), menu.setAttribute("onmouseleave", "this.style.display = 'none'; "), 
        menu;
    }
    onclickBtnAdd(obj) {
        let menu = obj.lastChild;
        menu.style.display = "flex";
    }
    getText(obj) {
        let txt = "";
        return "string" == typeof obj ? txt = obj : this.LANGUAGE in obj && (txt = obj[this.LANGUAGE]), 
        txt;
    }
    getNonEmplyText(obj) {
        if ("string" == typeof obj) return obj;
        if (this.LANGUAGE in obj && obj[this.LANGUAGE].length) return obj[this.LANGUAGE];
        for (var k in obj) if (obj[k].length) return obj[k];
        return "";
    }
    setText(obj, text) {
        obj[this.LANGUAGE] = text;
    }
    onkeydownText(ev) {
        if ("$" === ev.key) {
            qubotEditor.stateEditor.removeSlotsMenu();
            ev = ev.path || ev.composedPath && ev.composedPath();
            if (1 < ev.length) {
                let obj = ev[1], menu = qubotEditor.add(obj, "qubot-slots-menu");
                for (var slot in qubotEditor.bot.slots) {
                    let a;
                    a = "INPUT" === slot || "LANGUAGE" === slot || "INTENT" === slot || "CONFIDENCE" === slot ? qubotEditor.add(menu, "a-sys") : qubotEditor.add(menu, "a"), 
                    a.innerHTML = slot, a.setAttribute("onclick", "qubotEditor.stateEditor.insertText(this)");
                }
                var ev = obj.getBoundingClientRect(), recH = menu.getBoundingClientRect();
                let top = -1;
                ev.top + recH.height > document.documentElement.clientHeight && (top -= ev.top + recH.height - document.documentElement.clientHeight), 
                menu.style.left = obj.clientWidth + "px", menu.style.top = top + "px", menu.setAttribute("onmouseleave", "this.remove() ");
            }
        }
    }
    removeSlotsMenu() {
        let menus = document.getElementById("qubot-state-editor").getElementsByClassName("qubot-slots-menu");
        for (let i = 0; i < menus.length; i++) menus[i].remove();
    }
    insertText(obj) {
        let text = obj.parentNode.parentNode.getElementsByTagName("textarea");
        text.length && (text = text[0], qubotEditor.insertAtCursor(text, obj.innerHTML), 
        text.parentElement && text.parentElement.update && (text.parentElement.update(text.value), 
        text.parentElement.sync_scroll()), obj.parentNode.remove(), obj = new Event("input", {
            bubbles: !0,
            cancelable: !0
        }), text.dispatchEvent(obj), obj = new Event("change", {
            bubbles: !0,
            cancelable: !0
        }), text.dispatchEvent(obj));
    }
    insertAtCursor(myField, myValue) {
        var startPos, endPos;
        document.selection ? (myField.focus(), sel = document.selection.createRange(), sel.text = myValue) : myField.selectionStart || "0" == myField.selectionStart ? (startPos = myField.selectionStart, 
        endPos = myField.selectionEnd, myField.value = myField.value.substring(0, startPos) + myValue + myField.value.substring(endPos, myField.value.length)) : myField.value += myValue;
    }
}

class QuBotMyBotsUpload extends QuBotEditorBase {
    constructor() {
        super();
    }
    create() {
        for (this.pageUpload = document.getElementById("qubot-page-upload"); this.pageUpload.firstChild; ) this.pageUpload.removeChild(this.pageUpload.lastChild);
        qubotData.load("qubotUpload", function(data) {
            "wp" in (data = data || {}) || (data = {
                wp: {
                    isToken: !1,
                    upload: !1,
                    bid: "",
                    time: 0,
                    all: !0,
                    pages: {}
                }
            }), this.uploadData = data, this.create1();
        }.bind(this));
    }
    create1() {
        qubotData.load("qubotEditorMyBots", function(data) {
            if (data) {
                this.myBots = data;
                let botName = "";
                for (let i = 0; i < this.myBots.bots.length; i++) this.uploadData.wp.bid == this.myBots.bots[i].id && (botName = this.myBots.bots[i].name);
                data = this.add(this.pageUpload, "group");
                this.startInfo = this.add(data, "label");
                let btn = this.add(data, "button", "button"), label = (btn.setAttribute("onclick", "qubotConsole.pageUpload.onclickUploadBot(this)"), 
                this.uploadData.wp.upload ? (this.startInfo.innerHTML = `<b>Bot "${botName}" is ENABLED</b>`, 
                btn.innerHTML = "Stop") : (this.startInfo.innerHTML = "<b>No bot is running:</b>", 
                btn.innerHTML = "Start"), this.add(data, null, "hr"), data = this.add(this.pageUpload, "group"), 
                this.add(data, "label"));
                label.innerHTML = "<b>1. Select bot:</b>", this.selectMyBots = this.add(data, "select", "select"), 
                this.selectMyBots.setAttribute("onchange", "qubotConsole.pageUpload.onchangeUploadBot(this)");
                for (let i = 0; i < this.myBots.bots.length; i++) {
                    let op = this.add(this.selectMyBots, null, "option");
                    op.value = this.myBots.bots[i].id, op.innerHTML = this.myBots.bots[i].name, this.uploadData.wp.bid == this.myBots.bots[i].id && op.setAttribute("selected", "selected");
                }
                this.create2();
            }
        }.bind(this));
    }
    create2() {
        qubotData.load("qubotSitePages", function(data) {
            var group = this.add(this.pageUpload, "group");
            let label = this.add(group, "label");
            label.innerHTML = "<b>2. Select page:</b>";
            var item = this.add(group, "item");
            if (this.checkAll = this.add(item, "checkbox", "input"), this.checkAll.type = "checkbox", 
            this.checkAll.setAttribute("onchange", "qubotConsole.pageUpload.onchangeAllPages(this)"), 
            this.uploadData.wp.all && (this.checkAll.checked = !0), label = this.add(item, null, "label"), 
            label.innerHTML = "All pages", data) {
                group = this.add(this.pageUpload, "group"), label = this.add(group, "label"), label.innerHTML = "Selected pages:", 
                this.pagesList = this.add(group, "pages-list");
                for (let i = 0; i < data.length; i++) {
                    let item = this.add(this.pagesList, "item"), chk = this.add(item, "checkbox", "input"), label = (chk.type = "checkbox", 
                    (this.uploadData.wp.all || data[i].id in this.uploadData.wp.pages) && (chk.checked = !0), 
                    chk.setAttribute("value", data[i].id), chk.setAttribute("onchange", "qubotConsole.pageUpload.onchangePage(this)"), 
                    this.add(item, "label", "label"));
                    label.innerHTML = data[i].name;
                }
            }
            this.create3();
        }.bind(this));
    }
    create3() {
        let group = this.add(this.pageUpload, "group"), label = this.add(group, "label");
        label.innerHTML = "<b>3. Set time until the bot opens (sec):</b>", this.uploadTime = this.add(group, "input", "input"), 
        this.uploadTime.value = this.uploadData.wp.time, group = this.add(this.pageUpload, "group"), 
        label = this.add(group, null, "p"), label.innerHTML = 'To use extended data storage option instead of the WordPress default database, you will need to visit <a href="https://console.qudata.com?from=wp">https://console.qudata.com</a> and obtain your ID. <br>Filling the ID field below signifies the acceptance of access from the plugin to the external servers.', 
        label = this.add(group, "label"), label.innerHTML = "ID:", qubotData.load("qubotToken", function(data) {
            data = data ? data.token : "";
            this.uploadToken = this.add(group, "input", "input"), this.uploadToken.value = data, 
            this.uploadToken.onchange = this.onchangeToken.bind(this), qubotData.setClientToken(data);
        }.bind(this));
    }
    startAnalitics() {
        localStorage && localStorage.setItem("qubotBotsUID", "{}"), qubotManager.addBotEvent(this.selectMyBots.value, this.selectMyBots.options[this.selectMyBots.selectedIndex].text);
    }
    onchangeAllPages(obj) {
        let pages = this.pagesList.getElementsByTagName("input");
        for (let i = 0; i < pages.length; i++) pages[i].checked = obj.checked;
    }
    onchangeToken(obj) {
        qubotData.setClientToken(this.uploadToken.value), qubotData.save("qubotToken", JSON.stringify({
            token: this.uploadToken.value
        })), this.uploadData.wp.isToken = this.uploadToken.value && 10 < this.uploadToken.value.length, 
        qubotData.save("qubotUpload", JSON.stringify(this.uploadData)), this.startAnalitics();
    }
    onchangePage(obj) {
        obj.checked || (this.checkAll.checked = !1);
    }
    onchangeUploadBot(obj) {}
    onclickUploadBot(obj) {
        this.uploadData.wp.upload = !this.uploadData.wp.upload, this.uploadData.wp.bid = this.selectMyBots.value, 
        this.uploadData.wp.all = this.checkAll.checked, this.uploadData.wp.time = this.uploadTime.value, 
        this.uploadData.wp.isToken = this.uploadToken.value && 10 < this.uploadToken.value.length;
        var token = {
            token: this.uploadData.wp.isToken ? this.uploadToken.value : ""
        };
        if (qubotData.save("qubotToken", JSON.stringify(token)), this.uploadData.wp.pages = {}, 
        !this.uploadData.wp.all) {
            var pages = this.pagesList.getElementsByTagName("input");
            for (let i = 0; i < pages.length; i++) pages[i].checked && (this.uploadData.wp.pages[pages[i].value] = {});
        }
        console.log(this.uploadData), qubotData.save("qubotUpload", JSON.stringify(this.uploadData), function(status) {
            let botName = "";
            for (let i = 0; i < this.myBots.bots.length; i++) if (this.uploadData.wp.bid == this.myBots.bots[i].id) {
                botName = this.myBots.bots[i].name, qubotManager.set(this.myBots.bots[i]), qubotManager.bot.clear(), 
                qubotManager.bot.save();
                break;
            }
            this.uploadData.wp.upload ? (qubotEditor.help.alert("UploadBot"), obj.innerHTML = "Stop", 
            this.startInfo.innerHTML = `<b>Bot "${botName}" is ENABLED</b>`, this.startAnalitics()) : (qubotEditor.help.alert("UnUploadBot"), 
            obj.innerHTML = "Start", this.startInfo.innerHTML = "<b>No bot is running:</b>");
        }.bind(this));
    }
}

class QuBotSetupColor {
    constructor(r, g, b) {
        this.set(r, g, b);
    }
    toString() {
        return `rgb(${Math.round(this.r)}, ${Math.round(this.g)}, ${Math.round(this.b)})`;
    }
    set(r, g, b) {
        this.r = this.clamp(r), this.g = this.clamp(g), this.b = this.clamp(b);
    }
    hueRotate(angle = 0) {
        angle = angle / 180 * Math.PI;
        var sin = Math.sin(angle), angle = Math.cos(angle);
        this.multiply([ .213 + .787 * angle - .213 * sin, .715 - .715 * angle - .715 * sin, .072 - .072 * angle + .928 * sin, .213 - .213 * angle + .143 * sin, .715 + .285 * angle + .14 * sin, .072 - .072 * angle - .283 * sin, .213 - .213 * angle - .787 * sin, .715 - .715 * angle + .715 * sin, .072 + .928 * angle + .072 * sin ]);
    }
    grayscale(value = 1) {
        this.multiply([ .2126 + .7874 * (1 - value), .7152 - .7152 * (1 - value), .0722 - .0722 * (1 - value), .2126 - .2126 * (1 - value), .7152 + .2848 * (1 - value), .0722 - .0722 * (1 - value), .2126 - .2126 * (1 - value), .7152 - .7152 * (1 - value), .0722 + .9278 * (1 - value) ]);
    }
    sepia(value = 1) {
        this.multiply([ .393 + .607 * (1 - value), .769 - .769 * (1 - value), .189 - .189 * (1 - value), .349 - .349 * (1 - value), .686 + .314 * (1 - value), .168 - .168 * (1 - value), .272 - .272 * (1 - value), .534 - .534 * (1 - value), .131 + .869 * (1 - value) ]);
    }
    saturate(value = 1) {
        this.multiply([ .213 + .787 * value, .715 - .715 * value, .072 - .072 * value, .213 - .213 * value, .715 + .285 * value, .072 - .072 * value, .213 - .213 * value, .715 - .715 * value, .072 + .928 * value ]);
    }
    multiply(matrix) {
        var newR = this.clamp(this.r * matrix[0] + this.g * matrix[1] + this.b * matrix[2]), newG = this.clamp(this.r * matrix[3] + this.g * matrix[4] + this.b * matrix[5]), matrix = this.clamp(this.r * matrix[6] + this.g * matrix[7] + this.b * matrix[8]);
        this.r = newR, this.g = newG, this.b = matrix;
    }
    brightness(value = 1) {
        this.linear(value);
    }
    contrast(value = 1) {
        this.linear(value, -.5 * value + .5);
    }
    linear(slope = 1, intercept = 0) {
        this.r = this.clamp(this.r * slope + 255 * intercept), this.g = this.clamp(this.g * slope + 255 * intercept), 
        this.b = this.clamp(this.b * slope + 255 * intercept);
    }
    invert(value = 1) {
        this.r = this.clamp(255 * (value + this.r / 255 * (1 - 2 * value))), this.g = this.clamp(255 * (value + this.g / 255 * (1 - 2 * value))), 
        this.b = this.clamp(255 * (value + this.b / 255 * (1 - 2 * value)));
    }
    hsl() {
        var r = this.r / 255, g = this.g / 255, b = this.b / 255, max = Math.max(r, g, b), min = Math.min(r, g, b);
        let h, s, l = (max + min) / 2;
        if (max === min) h = s = 0; else {
            var d = max - min;
            switch (s = .5 < l ? d / (2 - max - min) : d / (max + min), max) {
              case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;

              case g:
                h = (b - r) / d + 2;
                break;

              case b:
                h = (r - g) / d + 4;
            }
            h /= 6;
        }
        return {
            h: 100 * h,
            s: 100 * s,
            l: 100 * l
        };
    }
    clamp(value) {
        return 255 < value ? value = 255 : value < 0 && (value = 0), value;
    }
    hexToRgb(hex) {
        hex = hex.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i, (m, r, g, b) => r + r + g + g + b + b);
        hex = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
        return hex ? [ parseInt(hex[1], 16), parseInt(hex[2], 16), parseInt(hex[3], 16) ] : null;
    }
}

class QuBotConsoleColorSolver {
    constructor(target, baseColor) {
        this.target = target, this.targetHSL = target.hsl(), this.reusedColor = new QuBotSetupColor(0, 0, 0);
    }
    solve() {
        var result = this.solveNarrow(this.solveWide());
        return {
            values: result.values,
            loss: result.loss,
            filter: this.css(result.values)
        };
    }
    solveWide() {
        var a = [ 60, 180, 18e3, 600, 1.2, 1.2 ];
        let best = {
            loss: 1 / 0
        };
        for (let i = 0; 25 < best.loss && i < 3; i++) {
            var result = this.spsa(5, a, 15, [ 50, 20, 3750, 50, 100, 100 ], 1e3);
            result.loss < best.loss && (best = result);
        }
        return best;
    }
    solveNarrow(wide) {
        var A = wide.loss, A1 = A + 1;
        return this.spsa(A, [ .25 * A1, .25 * A1, A1, .25 * A1, .2 * A1, .2 * A1 ], 2, wide.values, 500);
    }
    spsa(A, a, c, values, iters) {
        let best = null, bestLoss = 1 / 0;
        const deltas = new Array(6), highArgs = new Array(6), lowArgs = new Array(6);
        for (let k = 0; k < iters; k++) {
            var ck = c / Math.pow(k + 1, .16666666666666666);
            for (let i = 0; i < 6; i++) deltas[i] = .5 < Math.random() ? 1 : -1, highArgs[i] = values[i] + ck * deltas[i], 
            lowArgs[i] = values[i] - ck * deltas[i];
            var lossDiff = this.loss(highArgs) - this.loss(lowArgs);
            for (let i = 0; i < 6; i++) {
                var g = lossDiff / (2 * ck) * deltas[i], ak = a[i] / Math.pow(A + k + 1, 1);
                values[i] = function(value, idx) {
                    let max = 100;
                    2 === idx ? max = 7500 : 4 !== idx && 5 !== idx || (max = 200);
                    3 === idx ? value > max ? value %= max : value < 0 && (value = max + value % max) : value < 0 ? value = 0 : value > max && (value = max);
                    return value;
                }(values[i] - ak * g, i);
            }
            var loss = this.loss(values);
            loss < bestLoss && (best = values.slice(0), bestLoss = loss);
        }
        return {
            values: best,
            loss: bestLoss
        };
    }
    loss(filters) {
        const color = this.reusedColor;
        color.set(0, 0, 0), color.invert(filters[0] / 100), color.sepia(filters[1] / 100), 
        color.saturate(filters[2] / 100), color.hueRotate(3.6 * filters[3]), color.brightness(filters[4] / 100), 
        color.contrast(filters[5] / 100);
        filters = color.hsl();
        return Math.abs(color.r - this.target.r) + Math.abs(color.g - this.target.g) + Math.abs(color.b - this.target.b) + Math.abs(filters.h - this.targetHSL.h) + Math.abs(filters.s - this.targetHSL.s) + Math.abs(filters.l - this.targetHSL.l);
    }
    css(filters) {
        function fmt(idx, multiplier = 1) {
            return Math.round(filters[idx] * multiplier);
        }
        return `invert(${fmt(0)}%) sepia(${fmt(1)}%) saturate(${fmt(2)}%) hue-rotate(${fmt(3, 3.6)}deg) brightness(${fmt(4)}%) contrast(${fmt(5)}%)`;
    }
}

function hexToRgb(hex) {
    hex = hex.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i, (m, r, g, b) => r + r + g + g + b + b);
    hex = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return hex ? [ parseInt(hex[1], 16), parseInt(hex[2], 16), parseInt(hex[3], 16) ] : null;
}

class QuBotSetupStyles {
    constructor() {
        this.params = {
            botID: "hello",
            setup_pos: "rb",
            setup_pos_x: "50",
            setup_pos_y: "50",
            setup_logo_id: "0",
            setup_agent_id: "1",
            setup_human_id: "6",
            "text-sender-name": "Qu",
            "text-bot-name": "QuBot",
            "text-info": "We are always in touch with you",
            "icon-logo1": "url(icons/logo01a.png)",
            "icon-logo2": "url(icons/logo01b.png)",
            "icon-agent": "url(icons/logo01a.png)",
            "icon-human": "url(icons/robot09.png)",
            "icon-close": "url(svg/close.svg)",
            "icon-send": "url(svg/send.svg)",
            width: "400px",
            height: "600px",
            left: "none",
            right: "50px",
            top: "none",
            bottom: "50px",
            "shadow-size": "10px",
            "shadow-blur": "20px",
            "shadow-color": "#646464b2",
            "header-background": "#ffffff",
            "header-line-width": "1px",
            "header-line-color": "#ffffff",
            "header-color": "#0000ff",
            "header-font-size": "18px",
            "header-font-line": "18px",
            "header-info-color": "#0000ff",
            "header-info-size": "12px",
            "header-info-line": "12px",
            "header-shadow-size": "5px",
            "header-shadow-blur": "20px",
            "header-shadow-color": "#646464b2",
            "top-radius": "20px",
            "body-background": "#ffffff",
            "body-line-color": "#ffffff",
            "body-line-width": "1px",
            "body-backround-image": "none",
            "body-time-size": "10px",
            "body-time-color": "#000000",
            "mes-shadow-size": "0px",
            "mes-shadow-blur": "0px",
            "mes-shadow-color": "#646464b2",
            "mes-radius": "20px",
            "mes-padding": "10px",
            "footer-background": "#ffffff",
            "footer-line-width": "1px",
            "footer-line-color": "#ffffff",
            "footer-shadow-size": "3px",
            "footer-shadow-blur": "15px",
            "footer-shadow-color": "#646464b2",
            "footer-height": "30px",
            "bottom-radius": "20px",
            "input-background": "#ffffff",
            "input-font-color": "#000000",
            "input-font-size": "16px",
            "input-radius": "100px",
            "input-height": "30px",
            "input-margin-x": "5px",
            "input-margin-y": "5px",
            "input-line-width": "1px",
            "input-line-color": "#000000",
            "answer-background": "#0079fe",
            "answer-line-color": "#0079fe",
            "answer-line-size": "1px",
            "answer-color": "#ffffff",
            "answer-font-size": "18px",
            "answer-font-line": "20px",
            "icon-human-size": "30px",
            "message-background": "#f7f7f7",
            "message-line-color": "#212529",
            "message-line-width": "1px",
            "message-color": "#212529",
            "message-font-size": "18px",
            "message-font-line": "20px",
            "sender-color": "#0000ff",
            "sender-font-size": "13px",
            "sender-font-line": "15px",
            "icon-agent-size": "30px",
            "open-radius": "70px",
            "open-radius-img": "70px",
            "button-background1": "#ffffff",
            "button-background2": "#f0f0f0",
            "button-background3": "#a0a0a0",
            "button-line-color": "#212529",
            "button-line-width": "1px",
            "button-radius": "20px",
            "button-height": "30px",
            "button-color": "#212529",
            "button-font-size": "18px",
            "button-font-line": "20px",
            "button-margin": "3px",
            "icon-human-display": "block",
            "icon-agent-display": "block",
            "open-line": "0px",
            "open-color": "black",
            "close-color1": "#00aaff",
            "close-color2": "#00ccff",
            "send-color1": "#00aaff",
            "send-color2": "#00ccff"
        }, this.styles = [ {
            file: "style1.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "0",
                setup_agent_id: "1",
                setup_human_id: "6",
                "icon-logo1": "url(icons/logo01a.png)",
                "icon-logo2": "url(icons/logo01b.png)",
                "icon-human": "url(icons/robot09.png)",
                "icon-agent": "url(icons/logo01a.png)",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "none",
                right: "50px",
                top: "none",
                bottom: "50px",
                "shadow-size": "10px",
                "shadow-blur": "20px",
                "shadow-color": "#646464b2",
                "header-background": "#ffffff",
                "header-line-width": "1px",
                "header-line-color": "#ffffff",
                "header-color": "#0000ff",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#0000ff",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "5px",
                "header-shadow-blur": "20px",
                "header-shadow-color": "#646464b2",
                "top-radius": "20px",
                "body-background": "#ffffff",
                "body-line-color": "#ffffff",
                "body-line-width": "1px",
                "body-backround-image": "none",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "20px",
                "mes-padding": "10px",
                "footer-background": "#ffffff",
                "footer-line-width": "1px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "3px",
                "footer-shadow-blur": "15px",
                "footer-shadow-color": "#646464b2",
                "bottom-radius": "20px",
                "answer-background": "#0079fe",
                "answer-line-color": "#0079fe",
                "answer-line-size": "1px",
                "answer-color": "#ffffff",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#f7f7f7",
                "message-line-color": "#212529",
                "message-line-width": "1px",
                "message-color": "#212529",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#0000ff",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#ffffff",
                "button-background2": "#f0f0f0",
                "button-background3": "#a0a0a0",
                "button-line-color": "#212529",
                "button-line-width": "1px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#212529",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-background": "#ffffff",
                "input-font-color": "#000000",
                "icon-human-display": "block",
                "icon-agent-display": "block",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#00aaff",
                "close-color2": "#00ccff",
                "send-color1": "#00aaff",
                "send-color2": "#00ccff"
            }
        }, {
            file: "style_linux_az1.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "0",
                setup_agent_id: "2",
                setup_human_id: "0",
                "icon-logo1": "url(icons/logo01a.png)",
                "icon-logo2": "url(icons/logo01b.png)",
                "icon-human": "url('icons/empty.png')",
                "icon-agent": "url('icons/robot02.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "none",
                right: "50px",
                top: "none",
                bottom: "50px",
                "shadow-size": "0px",
                "shadow-blur": "0px",
                "shadow-color": "#c8c8c8b2",
                "header-background": "#f0f0f0",
                "header-line-width": "0px",
                "header-line-color": "#404040",
                "header-color": "#000000",
                "header-font-size": "20px",
                "header-font-line": "20px",
                "header-info-color": "#000001",
                "header-info-size": "14px",
                "header-info-line": "5px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "0px",
                "header-shadow-color": "#646464b2",
                "top-radius": "14px",
                "body-background": "#ffffffff",
                "body-line-color": "#404040",
                "body-line-width": "0px",
                "body-backround-image": "none",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "14px",
                "mes-padding": "10px",
                "footer-background": "#f0f0f0",
                "footer-line-width": "0px",
                "footer-line-color": "#404040",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "0px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "14px",
                "input-background": "#ffffff",
                "input-font-color": "#000000",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#000000",
                "answer-background": "#ffffff",
                "answer-line-color": "#646464",
                "answer-line-size": "1px",
                "answer-color": "#000000",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#7f7f7f",
                "message-line-color": "#212529",
                "message-line-width": "1px",
                "message-color": "#ffffff",
                "message-font-size": "20px",
                "message-font-line": "20px",
                "sender-font-size": "15px",
                "sender-font-line": "18px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#ffffff",
                "button-background2": "#f0f0f0",
                "button-background3": "#a0a0a0",
                "button-line-color": "#212529",
                "button-line-width": "1px",
                "button-radius": "14px",
                "button-height": "24px",
                "button-color": "#212529",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "none",
                "icon-agent-display": "block",
                "open-line": "1px",
                "open-color": "black",
                "close-color1": "#646464",
                "close-color2": "#e01010",
                "send-color1": "#646464",
                "send-color2": "#e01010",
                "win-line": "1px",
                "mes-line": "1px"
            }
        }, {
            file: "style_k01.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "0",
                setup_agent_id: "0",
                setup_human_id: "0",
                "icon-logo1": "url(icons/logo01a.png)",
                "icon-logo2": "url(icons/logo01b.png)",
                "icon-human": "url('icons/empty.png')",
                "icon-agent": "url('icons/empty.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "4px",
                "shadow-blur": "12px",
                "shadow-color": "#646464b2",
                "header-background": "#efeff3",
                "header-line-width": "0px",
                "header-line-color": "#ffffff",
                "header-color": "#307aff",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#307aff",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "2px",
                "header-shadow-color": "#646464b2",
                "top-radius": "12px",
                "body-background": "#ffffffff",
                "body-line-color": "#ffffff",
                "body-line-width": "0px",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "body-backround-image": "none",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#efeff3",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#ffffff",
                "input-font-color": "#000000",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#cbcbce",
                "answer-background": "#1e82fe",
                "answer-line-color": "#1e82fe",
                "answer-line-size": "0px",
                "answer-color": "#ffffff",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#f0f0f4",
                "message-line-color": "#212529",
                "message-line-width": "0px",
                "message-color": "#000000",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#307aff",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#ffffff",
                "button-background2": "#f0f0f4",
                "button-background3": "#cbcbce",
                "button-line-color": "#cbcbce",
                "button-line-width": "1px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#307aff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "none",
                "icon-agent-display": "none",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#307aff",
                "close-color2": "#71a1f9",
                "send-color1": "#307aff",
                "send-color2": "#71a1f9",
                "close-color3": "#00ccff",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "win-line": "1px",
                "mes-line": "1px"
            }
        }, {
            file: "style_k02.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "0",
                setup_agent_id: "0",
                setup_human_id: "0",
                "icon-logo1": "url(icons/logo01a.png)",
                "icon-logo2": "url(icons/logo01b.png)",
                "icon-human": "url('icons/empty.png')",
                "icon-agent": "url('icons/empty.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "4px",
                "shadow-blur": "12px",
                "shadow-color": "#646464b2",
                "header-background": "#323c50",
                "header-line-width": "0px",
                "header-line-color": "#ffffff",
                "header-color": "#30a6ff",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#30a6ff",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "2px",
                "header-shadow-color": "#646464b2",
                "top-radius": "12px",
                "body-background": "#19232dff",
                "body-line-color": "#ffffff",
                "body-line-width": "0px",
                "body-time-size": "10px",
                "body-time-color": "#808080",
                "body-backround-image": "none",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#323c50",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#19232d",
                "input-font-color": "#ffffff",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#cbcbce",
                "answer-background": "#406a96",
                "answer-line-color": "#406a96",
                "answer-line-size": "0px",
                "answer-color": "#ffffff",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#203042",
                "message-line-color": "#203042",
                "message-line-width": "0px",
                "message-color": "#ffffff",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#30a6ff",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#203042",
                "button-background2": "#ffffff",
                "button-background3": "#cbcbce",
                "button-line-color": "#cbcbce",
                "button-line-width": "1px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#3ba6ff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "none",
                "icon-agent-display": "none",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#30a6ff",
                "close-color2": "#0091ff",
                "send-color1": "#25a4ff",
                "send-color2": "#0091ff",
                "close-color3": "#00ccff",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "win-line": "1px",
                "mes-line": "1px"
            }
        }, {
            file: "style_k03.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "0",
                setup_agent_id: "0",
                setup_human_id: "0",
                "icon-logo1": "url(icons/logo01a.png)",
                "icon-logo2": "url(icons/logo01b.png)",
                "icon-human": "url('icons/empty.png')",
                "icon-agent": "url('icons/empty.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "0px",
                "shadow-blur": "2px",
                "shadow-color": "#646464b2",
                "header-background": "#efeff33f",
                "header-line-width": "0px",
                "header-line-color": "#ffffff",
                "header-color": "#307aff",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#307aff",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "2px",
                "header-shadow-color": "#646464b2",
                "top-radius": "12px",
                "body-background": "#ffffff3f",
                "body-line-color": "#ffffff",
                "body-line-width": "0px",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "body-backround-image": "none",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "6px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#efeff33f",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#ffffff",
                "input-font-color": "#000000",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "4px",
                "input-margin-y": "4px",
                "input-line-width": "1px",
                "input-line-color": "#cbcbce",
                "answer-background": "#1e82fe",
                "answer-line-color": "#1e82fe",
                "answer-line-size": "0px",
                "answer-color": "#ffffff",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#f0f0f4",
                "message-line-color": "#212529",
                "message-line-width": "0px",
                "message-color": "#000000",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#307aff",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#ffffff",
                "button-background2": "#f0f0f4",
                "button-background3": "#cbcbce",
                "button-line-color": "#cbcbce",
                "button-line-width": "1px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#307aff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "none",
                "icon-agent-display": "none",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#307aff",
                "close-color2": "#71a1f9",
                "send-color1": "#307cff",
                "send-color2": "#71a1f9",
                "close-color3": "#00ccff",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "win-line": "1px",
                "mes-line": "1px"
            }
        }, {
            file: "style_k04.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "9",
                setup_agent_id: "9",
                setup_human_id: "6",
                "text-sender-name": "Qu",
                "text-bot-name": "QuBot",
                "text-info": "We are always in touch with you",
                "icon-logo1": "url('icons/robot07.png')",
                "icon-logo2": "url('icons/robot07.png')",
                "icon-human": "url('icons/robot09.png')",
                "icon-agent": "url('icons/robot06.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "4px",
                "shadow-blur": "12px",
                "shadow-color": "#646464b2",
                "header-background": "#fcfcfcff",
                "header-line-width": "0px",
                "header-line-color": "#ffffff",
                "header-color": "#212121",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#212121",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "2px",
                "header-shadow-color": "#646464b2",
                "top-radius": "12px",
                "body-background": "#ffffffff",
                "body-line-color": "#ffffff",
                "body-line-width": "0px",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "body-backround-image": "url('backs/sky.jpg')  ",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#fcfcfcff",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#fcfcfc",
                "input-font-color": "#000000",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#222222",
                "answer-background": "#8cbcff",
                "answer-line-color": "#6586ae",
                "answer-line-size": "1px",
                "answer-color": "#202020",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#dfdef5",
                "message-line-color": "#b8b7c2",
                "message-line-width": "1px",
                "message-color": "#212121",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#7077e5",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#f65e93",
                "button-background2": "#ea90b6",
                "button-background3": "#e50358",
                "button-line-color": "#a30041",
                "button-line-width": "1px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#ffffff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "block",
                "icon-agent-display": "block",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#212121",
                "close-color2": "#636363",
                "send-color1": "#222222",
                "send-color2": "#636363",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "close-color3": "#00ccff",
                "win-line": "1px",
                "mes-line": "1px",
                styleID: "5"
            }
        }, {
            file: "style_k06.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "7",
                setup_agent_id: "8",
                setup_human_id: "5",
                "text-sender-name": "Qu",
                "text-bot-name": "QuBot",
                "text-info": "We are always in touch with you",
                "icon-logo1": "url('icons/robot05.png')",
                "icon-logo2": "url('icons/robot05.png')",
                "icon-human": "url('icons/robot08.png')",
                "icon-agent": "url('icons/robot05.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "4px",
                "shadow-blur": "12px",
                "shadow-color": "#6b6d73b2",
                "header-background": "#ffffffff",
                "header-line-width": "0px",
                "header-line-color": "#ffffff",
                "header-color": "#a5a8b1",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#a5a8b1",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "2px",
                "header-shadow-color": "#6b6d73b2",
                "top-radius": "12px",
                "body-background": "#ffffffff",
                "body-line-color": "#ffffff",
                "body-line-width": "0px",
                "body-backround-image": "none",
                "body-time-size": "10px",
                "body-time-color": "#000000",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#ffffffff",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#ffffff",
                "input-font-color": "#6b6d73",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#a5a8b1",
                "answer-background": "#f6fbfc",
                "answer-line-color": "#f6fbfc",
                "answer-line-size": "0px",
                "answer-color": "#202020",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#f3fbf5",
                "message-line-color": "#b8b7c2",
                "message-line-width": "0px",
                "message-color": "#212121",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#6377e4",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#6377e4",
                "button-background2": "#b0b9ef",
                "button-background3": "#8098ef",
                "button-line-color": "#6377e4",
                "button-line-width": "0px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#ffffff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "block",
                "icon-agent-display": "block",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#a5a8b1",
                "close-color2": "#6b6d73",
                "send-color1": "#a5a8b1",
                "send-color2": "#6b6d73",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "close-color3": "#00ccff",
                "win-line": "1px",
                "mes-line": "1px",
                styleID: "5"
            }
        }, {
            file: "style_k07.jpg",
            params: {
                botID: "hello",
                setup_pos: "rb",
                setup_pos_x: "50",
                setup_pos_y: "50",
                setup_logo_id: "1",
                setup_agent_id: "21",
                setup_human_id: "4",
                "text-sender-name": "Qu",
                "text-bot-name": "QuBot",
                "text-info": "We are always in touch with you",
                "icon-logo1": "url('icons/logo02a.png')",
                "icon-logo2": "url('icons/logo02b.png')",
                "icon-human": "url('icons/smile04.png')",
                "icon-agent": "url('icons/animal01.png')",
                "icon-close": "url(svg/close.svg)",
                "icon-send": "url(svg/send.svg)",
                width: "400px",
                height: "600px",
                left: "auto",
                right: "50px",
                top: "auto",
                bottom: "50px",
                "shadow-size": "4px",
                "shadow-blur": "12px",
                "shadow-color": "#6b6d73b2",
                "header-background": "#47476bff",
                "header-line-width": "0px",
                "header-line-color": "#47476b",
                "header-color": "#f0eff2",
                "header-font-size": "18px",
                "header-font-line": "18px",
                "header-info-color": "#9fa2b1",
                "header-info-size": "12px",
                "header-info-line": "12px",
                "header-shadow-size": "0px",
                "header-shadow-blur": "0px",
                "header-shadow-color": "#6b6d73b2",
                "top-radius": "12px",
                "body-background": "#3b3d5bff",
                "body-line-color": "#3b3e5c",
                "body-line-width": "0px",
                "body-backround-image": "none",
                "body-time-size": "10px",
                "body-time-color": "#808080",
                "mes-shadow-size": "0px",
                "mes-shadow-blur": "0px",
                "mes-shadow-color": "#646464b2",
                "mes-radius": "12px",
                "mes-padding": "8px",
                "footer-background": "#47476bff",
                "footer-line-width": "0px",
                "footer-line-color": "#ffffff",
                "footer-shadow-size": "0px",
                "footer-shadow-blur": "2px",
                "footer-shadow-color": "#646464b2",
                "footer-height": "30px",
                "bottom-radius": "20px",
                "input-background": "#ffffff",
                "input-font-color": "#9fa2b1",
                "input-font-size": "16px",
                "input-radius": "100px",
                "input-height": "30px",
                "input-margin-x": "5px",
                "input-margin-y": "5px",
                "input-line-width": "1px",
                "input-line-color": "#9a72e7",
                "answer-background": "#9a72e7",
                "answer-line-color": "#9a72e7",
                "answer-line-size": "0px",
                "answer-color": "#dfdee5",
                "answer-font-size": "18px",
                "answer-font-line": "20px",
                "icon-human-size": "30px",
                "message-background": "#47476b",
                "message-line-color": "#47476b",
                "message-line-width": "0px",
                "message-color": "#dfdee5",
                "message-font-size": "18px",
                "message-font-line": "20px",
                "sender-color": "#9b9ead",
                "sender-font-size": "13px",
                "sender-font-line": "15px",
                "icon-agent-size": "30px",
                "open-radius": "70px",
                "open-radius-img": "70px",
                "button-background1": "#5d4df6",
                "button-background2": "#928cff",
                "button-background3": "#463abd",
                "button-line-color": "#5d4df6",
                "button-line-width": "0px",
                "button-radius": "20px",
                "button-height": "30px",
                "button-color": "#ffffff",
                "button-font-size": "18px",
                "button-font-line": "20px",
                "button-margin": "3px",
                "icon-human-display": "block",
                "icon-agent-display": "block",
                "open-line": "0px",
                "open-color": "black",
                "close-color1": "#eae9ee",
                "close-color2": "#9fa2b1",
                "send-color1": "#eaeaee",
                "send-color2": "#9fa2b1",
                "right-hide": "50px",
                "left-hide": "auto",
                "bottom-hide": "-1000px",
                "top-hide": "auto",
                "close-color3": "#00ccff",
                "win-line": "1px",
                "mes-line": "1px",
                styleID: "5"
            }
        } ];
    }
}

class QuBotSetup extends QuBotSetupStyles {
    constructor() {
        super(), this.logos1 = [ "logo01a.png", "logo02a.png", "logo03a.png", "robot01.png", "robot02.png", "robot03.png", "robot04.png", "robot05.png", "robot06.png", "robot07.png", "robot08.png", "robot09.png" ], 
        this.logos2 = [ "logo01b.png", "logo02b.png", "logo03b.png", "robot01.png", "robot02.png", "robot03.png", "robot04.png", "robot05.png", "robot06.png", "robot07.png", "robot08.png", "robot09.png" ], 
        this.agents = [ "empty.png", "logo01a.png", "logo02a.png", "logo03a.png", "robot01.png", "robot02.png", "robot03.png", "robot04.png", "robot05.png", "robot06.png", "robot07.png", "robot08.png", "robot09.png", "human01.png", "human02.png", "human03.png", "human04.png", "human05.png", "human06.png", "human07.png", "human08.png", "animal01.png", "animal02.png", "animal03.png", "animal04.png", "animal05.png", "animal06.png", "animal07.png", "smile01.png", "smile02.png", "smile03.png", "smile04.png" ], 
        this.humans = [ "empty.png", "smile01.png", "smile02.png", "smile03.png", "smile04.png", "robot08.png", "robot09.png" ], 
        this.dontSave = !1;
    }
    set(param, val, save = !0) {
        if (this.params[param] = val, 0 === param.indexOf("close-") || 0 === param.indexOf("send-")) {
            let color = new QuBotSetupColor(0, 0, 0);
            var rgb = color.hexToRgb(val);
            color.set(rgb[0], rgb[1], rgb[2]);
            let solver = new QuBotConsoleColorSolver(color);
            rgb = solver.solve();
            document.documentElement.style.setProperty("--qubot-" + param, rgb.filter);
        } else document.documentElement.style.setProperty("--qubot-" + param, val);
        save && this.save();
    }
    get(param) {
        return getComputedStyle(document.documentElement).getPropertyValue("--qubot-" + param).trim();
    }
    getParams() {
        let res = "";
        for (var p in this.params) res += `"${p}" : "${this.params[p]}",
`;
        navigator.clipboard.writeText(res);
    }
    color(color, alphaID) {
        let alpha = parseInt(document.getElementById(alphaID).value);
        return alpha = Math.floor(255 * alpha / 100).toString(16), 1 == alpha.length && (alpha = "0" + alpha), 
        color + alpha;
    }
    addIcons(id, icons) {
        var list = document.getElementById(id);
        for (let i = 0; i < icons.length; i++) {
            var icon = this.add(list, "icon");
            let img = this.add(icon, null, "img"), chk = this.add(icon, null, "input");
            img.setAttribute("src", "" + qubotData.pathIcons + icons[i]), chk.type = "checkbox", 
            chk.setAttribute("onclick", `qubotSetup.checkIcon(this, '${id}')`), chk.name = "" + i, 
            chk.id = "qubot-" + id + "-" + i;
        }
    }
    checkIcon(checkbox, id) {
        var dontSave = this.dontSave;
        this.dontSave = !0;
        let div = document.getElementById(id);
        var icon = div.getElementsByClassName("icon"), icon = (Array.from(icon).forEach(item => {
            item.childNodes[1].checked = !1;
        }), checkbox.checked = !0, parseInt(checkbox.name));
        "icons-logo" == id ? (this.params.setup_logo_id = icon, this.set("icon-logo1", `url('icons/${this.logos1[icon]}')`), 
        this.set("icon-logo2", `url('icons/${this.logos2[icon]}')`)) : "icons-agent" == id ? (0 == (this.params.setup_agent_id = icon) ? this.set("icon-agent-display", "none") : this.set("icon-agent-display", "block"), 
        this.set("icon-agent", `url('icons/${this.agents[icon]}')`)) : "icons-human" == id && (0 == (this.params.setup_human_id = icon) ? this.set("icon-human-display", "none") : this.set("icon-human-display", "block"), 
        this.set("icon-human", `url('icons/${this.humans[icon]}')`)), this.dontSave = !1, 
        dontSave || this.save();
    }
    addStyles(id, styles) {
        var icon = document.getElementsByClassName("icon"), list = (Array.from(icon).forEach(item => {
            item.childNodes[1].checked = !1;
        }), document.getElementById(id)), icon = this.params, styleID = void 0 === icon.styleID ? 0 : icon.styleID;
        for (let i = 0; i < styles.length; i++) {
            var item = this.add(list, "item");
            let img = this.add(item, null, "img"), chk = this.add(item, "qubot-setup-sheck-style", "input");
            i == styleID && (chk.checked = !0), img.setAttribute("onclick", `qubotSetup.checkStyle(this, '${id}')`), 
            img.setAttribute("src", "" + qubotData.pathStyles + styles[i].file), chk.type = "checkbox", 
            chk.setAttribute("onclick", `qubotSetup.checkStyle(this, '${id}')`), chk.name = "" + i;
        }
    }
    checkStyle(checkbox, id) {
        var dontSave = this.dontSave, icon = (this.dontSave = !0, document.getElementsByClassName("icon"));
        Array.from(icon).forEach(item => {
            item.childNodes[1].checked = !1;
        });
        let div = document.getElementById(id);
        icon = div.getElementsByClassName("item"), Array.from(icon).forEach(item => {
            item.childNodes[1].checked = !1;
        }), (checkbox = "img" === checkbox.localName ? checkbox.nextSibling : checkbox).checked = !0;
        id = parseInt(checkbox.name);
        let params = this.styles[id].params;
        params.styleID = id, this.setParams(params), this.setInterfaceData(), this.dontSave = !1, 
        dontSave || this.save();
    }
    checkSize(checkbox, id) {
        var dontSave = this.dontSave;
        this.dontSave = !0;
        let div = document.getElementById(id), w = (div.childNodes.forEach(item => {
            "item" == item.className && (item.firstChild.checked = !1);
        }), checkbox.checked = !0, document.getElementById("qubot-width")), h = document.getElementById("qubot-height");
        "[-1,-1]" == checkbox.value ? (w.disabled = h.disabled = !1, w.value = this.params.width.replace("px", ""), 
        h.value = this.params.height.replace("px", "")) : (id = JSON.parse(checkbox.value), 
        this.set("width", id[0] + "px"), this.set("height", id[1] + "px"), w.value = id[0], 
        h.value = id[1], w.disabled = h.disabled = !0), this.dontSave = !1, dontSave || this.save();
    }
    editSize(obj) {
        var val = this.getInt(obj.value, 400), obj = (obj.value = val, this.getInt(document.getElementById("qubot-width").value, 400)), val = this.getInt(document.getElementById("qubot-height").value, 600);
        this.set("width", obj), this.set("height", val);
    }
    checkPos(pos) {
        var dontSave = this.dontSave;
        this.dontSave = !0;
        let win = document.getElementById("qubot-pos");
        var items = win.getElementsByClassName("block");
        Array.from(items).forEach(item => {
            item.style.borderStyle = "none";
        }), document.getElementById("qubot-pos-lt").checked = !1, document.getElementById("qubot-pos-rt").checked = !1, 
        document.getElementById("qubot-pos-rb").checked = !1, document.getElementById("qubot-pos-lb").checked = !1;
        let chk = document.getElementById("qubot-pos-" + pos), div = chk.parentElement;
        chk.checked = !0, "lt" === pos ? (document.getElementById("qubot-pos-x-name").innerHTML = "Left", 
        document.getElementById("qubot-pos-y-name").innerHTML = "Top", div.style.borderBottomStyle = div.style.borderRightStyle = "dotted", 
        div.style.borderBottomWidth = div.style.borderRightWidth = "thin") : "rt" === pos ? (document.getElementById("qubot-pos-x-name").innerHTML = "Right", 
        document.getElementById("qubot-pos-y-name").innerHTML = "Top", div.style.borderBottomStyle = div.style.borderLeftStyle = "dotted", 
        div.style.borderBottomWidth = div.style.borderLeftWidth = "thin") : "lb" === pos ? (document.getElementById("qubot-pos-x-name").innerHTML = "Left", 
        document.getElementById("qubot-pos-y-name").innerHTML = "Bottom", div.style.borderTopStyle = div.style.borderRightStyle = "dotted", 
        div.style.borderTopWidth = div.style.borderRightWidth = "thin") : "rb" === pos && (document.getElementById("qubot-pos-x-name").innerHTML = "Right", 
        document.getElementById("qubot-pos-y-name").innerHTML = "Bottom", div.style.borderTopStyle = div.style.borderLeftStyle = "dotted", 
        div.style.borderTopWidth = div.style.borderLeftWidth = "thin"), this.params.setup_pos = pos, 
        this.editPos(), this.dontSave = !1, dontSave || this.save();
    }
    editPos() {
        this.setPos(document.getElementById("qubot-pos-x").value, document.getElementById("qubot-pos-y").value, this.params.setup_pos);
    }
    setPos(x, y, org) {
        var dontSave = this.dontSave;
        this.dontSave = !0, this.params.setup_pos = org, this.params.setup_pos_x = x, this.params.setup_pos_y = y;
        "l" == org[0] ? (this.set("left", x + "px"), this.set("right", "auto"), this.set("left-hide", x + "px"), 
        this.set("right-hide", "auto")) : (this.set("right", x + "px"), this.set("left", "auto"), 
        this.set("right-hide", x + "px"), this.set("left-hide", "auto")), "t" == org[1] ? (this.set("top", y + "px"), 
        this.set("bottom", "auto"), this.set("top-hide", "-1000px"), this.set("bottom-hide", "auto")) : (this.set("bottom", y + "px"), 
        this.set("top", "auto"), this.set("bottom-hide", "-1000px"), this.set("top-hide", "auto")), 
        this.dontSave = !1, dontSave || this.save();
    }
    add(parent, className, element = "div") {
        let block = document.createElement(element);
        return null !== className && (block.className = className), null !== parent && parent.append(block), 
        block;
    }
    getInt(str, def) {
        return isNaN(str) ? def : parseInt(str);
    }
    invertColor(hex) {
        function padZero(str, len) {
            return len = len || 2, (new Array(len).join("0") + str).slice(-len);
        }
        if (6 !== (hex = 3 === (hex = 0 === hex.indexOf("#") ? hex.slice(1) : hex).length ? hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2] : hex).length) throw new Error("Invalid HEX color.");
        var r = (255 - parseInt(hex.slice(0, 2), 16)).toString(16), g = (255 - parseInt(hex.slice(2, 4), 16)).toString(16), hex = (255 - parseInt(hex.slice(4, 6), 16)).toString(16);
        return "#" + padZero(r) + padZero(g) + padZero(hex);
    }
    pageSet(color) {
        var inv = this.invertColor(color);
        document.documentElement.style.setProperty("--console-menu-color", color), document.documentElement.style.setProperty("--console-menu-font-color", inv);
    }
    checkBot(obj, botID) {
        let list = document.getElementById("bots-list");
        var chks = list.getElementsByClassName("checkbox");
        Array.from(chks).forEach(item => {
            item.checked = !1;
        }), obj.checked = !0, this.params.botID = botID, qubotManager.close(), qubotManager.start(), 
        this.save();
    }
    setInterface() {
        this.load();
    }
    setInterfaceData() {
        for (var p in this.params) {
            let div = document.getElementById("qubot-" + p);
            if (null != div) {
                let val = this.params[p];
                "string" == typeof val && 0 < val.length && (val = val.replace("px", ""), val = val.replace(/"/g, ""), 
                val = val.replace(new RegExp("^[s]+|[s]+$", "g"), ""), "#" == val[0] && 9 == val.length && (val = val.substring(0, 7))), 
                div.value = val;
            }
        }
        document.getElementById("qubot-pos-x").value = this.params.setup_pos_x, document.getElementById("qubot-pos-y").value = this.params.setup_pos_y, 
        this.checkPos(this.params.setup_pos), document.getElementById("qubot-width").value = this.params.width.replace("px", ""), 
        document.getElementById("qubot-height").value = this.params.height.replace("px", "");
        let lo = document.getElementById("qubot-icons-logo-" + this.params.setup_logo_id), ag = (null != lo && (lo.checked = !0), 
        document.getElementById("qubot-icons-agent-" + this.params.setup_agent_id)), hu = (null != ag && (ag.checked = !0), 
        document.getElementById("qubot-icons-human-" + this.params.setup_human_id));
        null != hu && (hu.checked = !0);
    }
    setParams(params) {
        for (var param in params) {
            let val = params[param];
            0 === param.indexOf("text-") && (val = '"' + val + '"'), this.params[param] = val, 
            this.set(param, val, !1);
        }
    }
    save() {
        if (!this.dontSave) {
            for (var param in this.params) {
                let val = this.params[param];
                "string" == typeof val && 0 < val.length && (this.params[param] = val.replace('"', ""));
            }
            qubotData.save("qubotSetup", JSON.stringify(this.params));
        }
    }
    load(setPage = !0) {
        qubotData.load("qubotSetup", function(data) {
            data && this.setParams(data), setPage && (this.addIcons("icons-logo", this.logos1), 
            this.addIcons("icons-agent", this.agents), this.addIcons("icons-human", this.humans), 
            this.addStyles("styles-list", this.styles), this.setInterfaceData(), window.scrollTo(0, 0));
        }.bind(this));
    }
}